
// ==========================================================================
// File:        TDx_Library_Functions.CPP
// Description: This file implements standard functions used with the various
//              TDx_Library components.
//
// "TDx_Library"
// (c) 2001, BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"

//---------------------------------------------------------------------------
// Function:    TDx_Library_ErrorString()
// Description: Use this function to return the name of the error.
//---------------------------------------------------------------------------
AnsiString	__fastcall	TDx_Library_ErrorString(int Error)
{
AnsiString str = "";
switch (Error)
    {
    case TDX_ERROR: str = "TDX_ERROR"; break;
    case TDX_BADPARAMS: str = "TDX_BADPARAMS"; break;
    case TDX_NOTCREATED: str = "TDX_NOTCREATED"; break;
    case TDX_ALREADYCREATED: str = "TDX_ALREADYCREATED"; break;
    }
return str;
}

//---------------------------------------------------------------------------
// Function:    TDx_Library_ErrorMessage()
// Description: Use this function to return information about the error.
//---------------------------------------------------------------------------
AnsiString	__fastcall	TDx_Library_ErrorMessage(int Error)
{
AnsiString msg = "";
switch (Error)
    {
    case TDX_ERROR: msg = "An error has occurred that should be corrected for this application to function correctly."; break;
    case TDX_BADPARAMS: msg = "A method was called with incorrect parameters."; break;
    case TDX_NOTCREATED: msg = "An attempt was made to use or destroy a component that has not yet been created."; break;
    case TDX_ALREADYCREATED: msg = "A component cannot be created when it is already created, it must be explicitly destroyed using the component's Destroy() method."; break;
    }
return msg;
}

// --------------------------------------------------------------------------
