// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDICondition.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDICondition Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDICondition.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDICondition*)
{
    new TDICondition(NULL);
}
// --------------------------------------------------------------------------
namespace Tdicondition
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDICondition)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDICondition::TDICondition()
// Description: The default constructor for the TDICondition object.
// --------------------------------------------------------------------------
__fastcall TDICondition::TDICondition(TComponent* Owner)
    : TDIForce(Owner)
{
fDICONDITION=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TDICondition::~TDICondition()
// Description: The destructor for the TDICondition object.
// --------------------------------------------------------------------------
__fastcall TDICondition::~TDICondition()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DICONDITION structures wrapped inside the TDICondition 
//              component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDICondition component wraps a single DICONDITION 
//              structure. To wrap multiple structures, set the 
//              TDICondition::ArraySize to the total number of internal 
//              structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDICondition::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDICONDITION;
    fDICONDITION = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDICONDITION = new DICONDITION[pArraySize];
    if (fDICONDITION==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDICONDITION::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DICONDITION structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DICONDITION* temp_DICONDITION = new DICONDITION[pArraySize];
        if (temp_DICONDITION==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDICONDITION::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DICONDITION structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DICONDITION[fArraySize], sizeof(DICONDITION)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DICONDITION[0], &fDICONDITION[0], sizeof(DICONDITION)*fArraySize);
        // de-allocate old memory
        delete[] fDICONDITION;
        // re-assign the new memory
        fDICONDITION = temp_DICONDITION;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DICONDITION* temp_DICONDITION = new DICONDITION[pArraySize];
            if (temp_DICONDITION==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDICONDITION::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DICONDITION structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DICONDITION[0], &fDICONDITION[0], sizeof(DICONDITION)*pArraySize);
            // de-allocate the old memory
            delete[] fDICONDITION;
            // re-assign the new memory
            fDICONDITION = temp_DICONDITION;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    DeadBand
// Description: The DeadBand property defines a zone where the condition is 
//              not active, centered around the position defined by 
//              TDICondition::Offset. 
//              
//              When the control device is positioned within the zone defined 
//              by Offset + or - DeadBand, the conditional force will not be 
//              applied. 
//              
//              This property can range from 0 to 10,000, representing the 
//              distance in both directions from the offset that is to be 
//              defined as the dead zone. 
// --------------------------------------------------------------------------
long __fastcall TDICondition::FGetDeadBand( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetDeadBand()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetDeadBand()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fDICONDITION[pArrayIndex].lDeadBand;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetDeadBand( dword pArrayIndex, long pDeadBand )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetDeadBand()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetDeadBand()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].lDeadBand = pDeadBand;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDICondition method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDICondition::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    NegativeCoefficient
// Description: The NegativeCoefficient property defines the coefficient 
//              constant applied to an axis on the negative side of the 
//              offset value. 
//              
//              This property is ignored and 
//              TDICondition::PositiveCoefficient is used for both positive 
//              and negative coefficients if support for separate 
//              coefficients is not available. 
//              
//              The coefficient is used as a multiplier to scale the effect 
//              and can range from -10,000 to 10,000 where the extreme values 
//              represent the maximum force output the device is capable of 
//              producing in either direction. 
//              
//              For example, this value may determine how fast a spring 
//              effect's force would increase as a device moved along an axis 
//              away from the offset value. 
// --------------------------------------------------------------------------
long __fastcall TDICondition::FGetNegativeCoefficient( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetNegativeCoefficient()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetNegativeCoefficient()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fDICONDITION[pArrayIndex].lNegativeCoefficient;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetNegativeCoefficient( dword pArrayIndex, long pNegativeCoefficient )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetNegativeCoefficient()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetNegativeCoefficient()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].lNegativeCoefficient = pNegativeCoefficient;
}
// --------------------------------------------------------------------------
// Property:    NegativeSaturation
// Description: The NegativeSaturation property defines the negative 
//              saturation point on an axis. 
//              
//              Negative saturation usually represents a point on the axis 
//              beyond which further movement will not affect the force being 
//              output by the device. 
//              
//              This property is ignored and TDICondition::PositiveSaturation 
//              is used for both positive and negative saturation if support 
//              for separate saturation values is not available. 
//              
//              This value can range from 0 to 10,000, representing the 
//              distance in the negative direction from TDICondition::Offset. 
// --------------------------------------------------------------------------
dword __fastcall TDICondition::FGetNegativeSaturation( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetNegativeSaturation()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetNegativeSaturation()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDICONDITION[pArrayIndex].dwNegativeSaturation;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetNegativeSaturation( dword pArrayIndex, dword pNegativeSaturation )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetNegativeSaturation()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetNegativeSaturation()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].dwNegativeSaturation = pNegativeSaturation;
}
// --------------------------------------------------------------------------
// Property:    Offset
// Description: The Offset property defines the offset from the zero or 
//              centered position of an axis at which the condition should 
//              apply.   
//              
//              This value is generally used only for spring or damper 
//              effects and represents the center or rest point of a spring 
//              effect, or the greatest velocity value for which damping 
//              force should be zero. 
//              
//              This value ranges from -10,000 to 10,000 where the extreme 
//              values represent the maximum travel of the device along the 
//              axis in either direction. 
// --------------------------------------------------------------------------
long __fastcall TDICondition::FGetOffset( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetOffset()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetOffset()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fDICONDITION[pArrayIndex].lOffset;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetOffset( dword pArrayIndex, long pOffset )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetOffset()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetOffset()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].lOffset = pOffset;
}
// --------------------------------------------------------------------------
// Property:    PositiveCoefficient
// Description: The PositiveCoefficient property defines the coefficient 
//              constant applied to an axis on the positive side of the 
//              offset value. 
//              
//              This property is used for both positive and negative 
//              coefficients if support for separate coefficients is not 
//              available. 
//              
//              The coefficient is used as a multiplier to scale the effect 
//              and can range from -10,000 to 10,000 where the extreme values 
//              represent the maximum force output the device is capable of 
//              producing in either direction. 
//              
//              For example, this value may determine how fast a spring 
//              effect's force would increase as a device moved along an axis 
//              away from the offset value. 
// --------------------------------------------------------------------------
long __fastcall TDICondition::FGetPositiveCoefficient( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetPositiveCoefficient()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetPositiveCoefficient()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fDICONDITION[pArrayIndex].lPositiveCoefficient;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetPositiveCoefficient( dword pArrayIndex, long pPositiveCoefficient )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetPositiveCoefficient()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetPositiveCoefficient()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].lPositiveCoefficient = pPositiveCoefficient;
}
// --------------------------------------------------------------------------
// Property:    PositiveSaturation
// Description: The PositiveSaturation property defines the positive 
//              saturation point on an axis. 
//              
//              This usually represents a point on the axis beyond which 
//              further movement will not affect the force being output by 
//              the device. 
//              
//              This property is used for both positive and negative 
//              saturations if support for separate saturation values is not 
//              available and will be ignored if there is no saturation 
//              support at all. 
//              
//              This value can range from 0 to 10,000, representing the 
//              distance in the positive direction from TDICondition::Offset. 
// --------------------------------------------------------------------------
dword __fastcall TDICondition::FGetPositiveSaturation( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetPositiveSaturation()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FGetPositiveSaturation()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDICONDITION[pArrayIndex].dwPositiveSaturation;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetPositiveSaturation( dword pArrayIndex, dword pPositiveSaturation )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetPositiveSaturation()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::FSetPositiveSaturation()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDICONDITION[pArrayIndex].dwPositiveSaturation = pPositiveSaturation;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal DICONDITION structure. 
// --------------------------------------------------------------------------
dword __fastcall TDICondition::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DICONDITION structures. This result is the same as 
//              multiplying TDICondition::ArraySize and TDICondition::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDICondition::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDICondition's internal DICONDITION structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDICondition::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDICondition::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDICONDITION[pArrayIndex], sizeof(DICONDITION) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DICONDITION structures of the TDICondition 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDICondition::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDICondition::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDICONDITION[0], sizeof(DICONDITION)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DICONDITION* __fastcall TDICondition::FGetInternal_DICONDITION_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDICondition::FGetInternal_DICONDITION_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDICONDITION;
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::FSetInternal_DICONDITION( dword pArrayIndex, DICONDITION* pDICONDITION )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDICondition::FSetInternal_DICONDITION()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDICONDITION==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDICondition::FSetInternal_DICONDITION()", "TDX_ERROR", "The supplied DICONDITION* was NULL" );
    return;
    }
CopyMemory( &fDICONDITION[pArrayIndex], pDICONDITION, sizeof(DICONDITION) );
Internal_DICONDITION_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDICondition::Internal_DICONDITION_Update()
{
}

// --------------------------------------------------------------------------
