// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIConstantForce.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIConstantForce 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIConstantForce.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIConstantForce*)
{
    new TDIConstantForce(NULL);
}
// --------------------------------------------------------------------------
namespace Tdiconstantforce
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIConstantForce)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIConstantForce::TDIConstantForce()
// Description: The default constructor for the TDIConstantForce object.
// --------------------------------------------------------------------------
__fastcall TDIConstantForce::TDIConstantForce(TComponent* Owner)
    : TDIForce(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIConstantForce::~TDIConstantForce()
// Description: The destructor for the TDIConstantForce object.
// --------------------------------------------------------------------------
__fastcall TDIConstantForce::~TDIConstantForce()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIConstantForce method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIConstantForce::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Magnitude
// Description: The Magnitude property defines the magnitude of the force to 
//              be applied. 
//              
//              This value can range from -10,000 to 10,000 where the extreme 
//              values represent the maximum force output the device is 
//              capable of in either direction along the axis. 
//              
//              If an envelope is being applied, this value defines the force 
//              magnitude applied during the sustain period. 
// --------------------------------------------------------------------------
long __fastcall TDIConstantForce::FGetMagnitude()
{
return fDICONSTANTFORCE.lMagnitude;
}
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::FSetMagnitude( long pMagnitude )
{
fDICONSTANTFORCE.lMagnitude = pMagnitude;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DICONSTANTFORCE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIConstantForce::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIConstantForce's internal DICONSTANTFORCE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::Clear()
{
fErrorValue = DI_OK;
fDICONSTANTFORCE.lMagnitude = 0;
fSize = sizeof(DICONSTANTFORCE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DICONSTANTFORCE* __fastcall TDIConstantForce::FGetInternal_DICONSTANTFORCE_Ptr()
{
return &fDICONSTANTFORCE;
}
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::FSetInternal_DICONSTANTFORCE( DICONSTANTFORCE* pDICONSTANTFORCE )
{
if (pDICONSTANTFORCE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIConstantForce::FSetInternal_DICONSTANTFORCE()", "TDX_ERROR", "The supplied DICONSTANTFORCE* was NULL" );
    return;
    }

CopyMemory( &fDICONSTANTFORCE, pDICONSTANTFORCE, sizeof(DICONSTANTFORCE) );
Internal_DICONSTANTFORCE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIConstantForce::Internal_DICONSTANTFORCE_Update()
{
}

// --------------------------------------------------------------------------
