// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDICustomForce.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDICustomForce Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDICustomForce.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDICustomForce*)
{
    new TDICustomForce(NULL);
}
// --------------------------------------------------------------------------
namespace Tdicustomforce
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDICustomForce)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDICustomForce::TDICustomForce()
// Description: The default constructor for the TDICustomForce object.
// --------------------------------------------------------------------------
__fastcall TDICustomForce::TDICustomForce(TComponent* Owner)
    : TDIForce(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDICustomForce::~TDICustomForce()
// Description: The destructor for the TDICustomForce object.
// --------------------------------------------------------------------------
__fastcall TDICustomForce::~TDICustomForce()
{
}
// --------------------------------------------------------------------------
// Property:    Channels
// Description: The Channels property defines the number of channels (axes) 
//              that are to be affected by the force. 
//              
//              The first channel is applied to the first axis associated 
//              with the effect, the second to the second, etc. 
//              Nothing will be associated with axes in surplus of the number 
//              of channels. 
//              
//              When there's one channel the effect will be rotated in the 
//              direction specified by TDIEffect::Direction. 
//              Rotation of custom effects is not supported by all devices. 
//              When there are multiple channels rotation cannot take place. 
// --------------------------------------------------------------------------
dword __fastcall TDICustomForce::FGetChannels()
{
return fDICUSTOMFORCE.cChannels;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetChannels( dword pChannels )
{
fDICUSTOMFORCE.cChannels = pChannels;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDICustomForce method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDICustomForce::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    ForceData
// Description: The ForceData property references an array of force magnitude 
//              values representing the custom force. 
//              
//              When multiple channels are being used the values will be 
//              interleaved. 
//              Thus the first element of the array will belong to the first 
//              channel, the second to the second, etc. 
// --------------------------------------------------------------------------
long* __fastcall TDICustomForce::FGetForceData()
{
return fDICUSTOMFORCE.rglForceData;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetForceData( long* pForceData )
{
fDICUSTOMFORCE.rglForceData = pForceData;
}
// --------------------------------------------------------------------------
// Property:    SamplePeriod
// Description: The SamplePeriod property defines the length of time, in 
//              microseconds, each element in the TDICustomForce::ForceData 
//              array should be played. 
// --------------------------------------------------------------------------
dword __fastcall TDICustomForce::FGetSamplePeriod()
{
return fDICUSTOMFORCE.dwSamplePeriod;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetSamplePeriod( dword pSamplePeriod )
{
fDICUSTOMFORCE.dwSamplePeriod = pSamplePeriod;
}
// --------------------------------------------------------------------------
// Property:    Samples
// Description: The Samples property defines the total number of elements in 
//              the TDICustomForce::ForceData array. 
//              This value must be a multiple of TDICustomForce::Channels. 
// --------------------------------------------------------------------------
dword __fastcall TDICustomForce::FGetSamples()
{
return fDICUSTOMFORCE.cSamples;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetSamples( dword pSamples )
{
fDICUSTOMFORCE.cSamples = pSamples;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DICUSTOMFORCE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDICustomForce::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDICustomForce's internal DICUSTOMFORCE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::Clear()
{
fDICUSTOMFORCE.cChannels = 0;
fErrorValue = DI_OK;
fDICUSTOMFORCE.rglForceData = NULL;
fDICUSTOMFORCE.dwSamplePeriod = 0;
fDICUSTOMFORCE.cSamples = 0;
fSize = sizeof(DICUSTOMFORCE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DICUSTOMFORCE* __fastcall TDICustomForce::FGetInternal_DICUSTOMFORCE_Ptr()
{
return &fDICUSTOMFORCE;
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::FSetInternal_DICUSTOMFORCE( DICUSTOMFORCE* pDICUSTOMFORCE )
{
if (pDICUSTOMFORCE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDICustomForce::FSetInternal_DICUSTOMFORCE()", "TDX_ERROR", "The supplied DICUSTOMFORCE* was NULL" );
    return;
    }

CopyMemory( &fDICUSTOMFORCE, pDICUSTOMFORCE, sizeof(DICUSTOMFORCE) );
Internal_DICUSTOMFORCE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDICustomForce::Internal_DICUSTOMFORCE_Update()
{
}

// --------------------------------------------------------------------------
