// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIDataFormat.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIDataFormat Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIDataFormat.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIDataFormat*)
{
    new TDIDataFormat(NULL);
}
// --------------------------------------------------------------------------
namespace Tdidataformat
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIDataFormat)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIDataFormat::TDIDataFormat()
// Description: The default constructor for the TDIDataFormat object.
// --------------------------------------------------------------------------
__fastcall TDIDataFormat::TDIDataFormat(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDIDataFormat::~TDIDataFormat()
// Description: The destructor for the TDIDataFormat object.
// --------------------------------------------------------------------------
__fastcall TDIDataFormat::~TDIDataFormat()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    DataSize
// Description: The DataSize property defines the data packet size, in bytes, 
//              returned by the device. 
//              
//              This must be a multiple of 4 bytes (1 dword) and be larger 
//              than the highest offset for retrieving data from the object. 
// --------------------------------------------------------------------------
dword __fastcall TDIDataFormat::FGetDataSize()
{
return fDIDATAFORMAT.dwDataSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetDataSize( dword pDataSize )
{
fDIDATAFORMAT.dwDataSize = pDataSize;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIDataFormat method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIDataFormat::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating the mode used by 
//              the axes of the device. 
//              The described effect applies when the flag is set. 
//              
//              When using predefined data formats, this property may not be 
//              changed. You can, however, use TDx_InputDevice::SetPropery() 
//              after defining the data format but before acquiring the 
//              device to modify this setting. 
// Flags:       DIDF_ABSAXIS -
//                Use absolute coordinates to define the position of an axis. 
//                Axis coordinates are returned as a value relative to a 
//                fixed point established when the device was acquired. 
//                This flag and DIDF_RELAXIS are cannot both be set. 
//              DIDF_RELAXIS -
//                Use relative coordinates to define the position of an axis. 
//                Axis coordinates are returned as an amount of change 
//                relative to the last value that was returned. 
//                This flag and DIDF_ABSAXIS cannot both be set. 
// --------------------------------------------------------------------------
dword __fastcall TDIDataFormat::FGetFlags()
{
return fDIDATAFORMAT.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetFlags( dword pFlags )
{
fDIDATAFORMAT.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    NumObjs
// Description: The NumObjs property indicates how many elements the 
//              TDIDataFormat::ObjectFormats array holds. 
// --------------------------------------------------------------------------
dword __fastcall TDIDataFormat::FGetNumObjs()
{
return fDIDATAFORMAT.dwNumObjs;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetNumObjs( dword pNumObjs )
{
fDIDATAFORMAT.dwNumObjs = pNumObjs;
}
// --------------------------------------------------------------------------
// Property:    ObjectFormats
// Description: The ObjectFormats property references an array of 
//              TDIObjectDataFormat objects. 
//              
//              Each element of the array holds the format of an individual 
//              device control such as a single button or axis. 
//              Care should be taken not to enter the same information into 
//              multiple elements or multiple pieces of information into the 
//              same element. 
// --------------------------------------------------------------------------
TDIObjectDataFormat* __fastcall TDIDataFormat::FGetObjectFormats()
{
if (ComponentState.Contains(csDesigning) &&
    (fObjectFormats!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fObjectFormats)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fObjectFormats=NULL;
    }
return fObjectFormats;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetObjectFormats( TDIObjectDataFormat* pObjectFormats )
{
fObjectFormats = pObjectFormats;
fDIDATAFORMAT.rgodf = pObjectFormats->Internal_DIOBJECTDATAFORMAT_Ptr;
}
// --------------------------------------------------------------------------
// Property:    ObjectSize
// Description: The ObjectSize property defines the size, in bytes, of the 
//              TDIObjectDataFormat objects contained in the array referenced 
//              by TDIDataFormat::ObjectFormats. 
// --------------------------------------------------------------------------
dword __fastcall TDIDataFormat::FGetObjectSize()
{
return fDIDATAFORMAT.dwObjSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetObjectSize( dword pObjectSize )
{
fDIDATAFORMAT.dwObjSize = pObjectSize;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIDataFormat::FGetSize()
{
return fDIDATAFORMAT.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetSize( dword pSize )
{
fDIDATAFORMAT.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIDataFormat's internal DIDATAFORMAT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::Clear()
{
fDIDATAFORMAT.dwDataSize = 0;
fErrorValue = DI_OK;
fDIDATAFORMAT.dwFlags = 0;
fDIDATAFORMAT.dwNumObjs = 0;
fObjectFormats = NULL;
fDIDATAFORMAT.rgodf = NULL;
fDIDATAFORMAT.dwObjSize = 0;
fDIDATAFORMAT.dwSize = sizeof(DIDATAFORMAT);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIDATAFORMAT* __fastcall TDIDataFormat::FGetInternal_DIDATAFORMAT_Ptr()
{
return &fDIDATAFORMAT;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetInternal_DIDATAFORMAT( DIDATAFORMAT* pDIDATAFORMAT )
{
if (pDIDATAFORMAT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDataFormat::FSetInternal_DIDATAFORMAT()", "TDX_ERROR", "The supplied DIDATAFORMAT* was NULL" );
    return;
    }

CopyMemory( &fDIDATAFORMAT, pDIDATAFORMAT, sizeof(DIDATAFORMAT) );
Internal_DIDATAFORMAT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::Internal_DIDATAFORMAT_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDIDataFormat_Flags_Set<> of the flags 
//              in the current fDIDATAFORMAT.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIDataFormat_Flags_Set __fastcall TDIDataFormat::FGetFlags_()
{
TDIDataFormat_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDIDATAFORMAT.dwFlags & DIDF_ABSAXIS) TempFlags_ = TempFlags_ << didf_absaxis;
if (fDIDATAFORMAT.dwFlags & DIDF_RELAXIS) TempFlags_ = TempFlags_ << didf_relaxis;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDIDataFormat::FSetFlags_( TDIDataFormat_Flags_Set pFlags_ )
{
fDIDATAFORMAT.dwFlags = 0;
if (pFlags_.Contains(didf_absaxis)) fDIDATAFORMAT.dwFlags |= DIDF_ABSAXIS;
if (pFlags_.Contains(didf_relaxis)) fDIDATAFORMAT.dwFlags |= DIDF_RELAXIS;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIDataFormat::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIDataFormat::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDIDATAFORMAT.dwFlags & DIDF_ABSAXIS) fFlags_Strings->Add("DIDF_ABSAXIS");
if (fDIDATAFORMAT.dwFlags & DIDF_RELAXIS) fFlags_Strings->Add("DIDF_RELAXIS");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
