// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIDeviceObjectInstance.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIDeviceObjectInstance 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIDeviceObjectInstance.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIDeviceObjectInstance*)
{
    new TDIDeviceObjectInstance(NULL);
}
// --------------------------------------------------------------------------
namespace Tdideviceobjectinstance
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIDeviceObjectInstance)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIDeviceObjectInstance::TDIDeviceObjectInstance()
// Description: The default constructor for the TDIDeviceObjectInstance object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceObjectInstance::TDIDeviceObjectInstance(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
fType_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDIDeviceObjectInstance::~TDIDeviceObjectInstance()
// Description: The destructor for the TDIDeviceObjectInstance object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceObjectInstance::~TDIDeviceObjectInstance()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
if (fType_Strings!=NULL) delete fType_Strings;
}
// --------------------------------------------------------------------------
// Property:    CollectionNumber
// Description: The CollectionNumber property defines which HID link 
//              collection this object belongs to. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetCollectionNumber()
{
return fDIDEVICEOBJECTINSTANCE.wCollectionNumber;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetCollectionNumber( word pCollectionNumber )
{
fDIDEVICEOBJECTINSTANCE.wCollectionNumber = pCollectionNumber;
}
// --------------------------------------------------------------------------
// Property:    DesignatorIndex
// Description: The DesignatorIndex defines an index to a designator in the 
//              HID physical descriptor. 
//              
//              Additional information about the device object can be 
//              retrieved by passing this number to functions in the HID 
//              parsing library (Hidpi.h). 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetDesignatorIndex()
{
return fDIDEVICEOBJECTINSTANCE.wDesignatorIndex;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetDesignatorIndex( word pDesignatorIndex )
{
fDIDEVICEOBJECTINSTANCE.wDesignatorIndex = pDesignatorIndex;
}
// --------------------------------------------------------------------------
// Property:    Dimension
// Description: The Dimension property defines the units used when reporting 
//              a value for the object. 
//              
//              This property can be used to distinguish between the position 
//              and velocity of a control but will be zero if the dimensional 
//              units are not known. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetDimension()
{
return fDIDEVICEOBJECTINSTANCE.dwDimension;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetDimension( dword pDimension )
{
fDIDEVICEOBJECTINSTANCE.dwDimension = pDimension;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIDeviceObjectInstance method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIDeviceObjectInstance::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Exponent
// Description: The Exponent property defines the exponent associated with 
//              the dimension, if known. 
//              
//              Dimensional units are always integral, this exponent may be 
//              required for conversion to non-integral types. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetExponent()
{
return fDIDEVICEOBJECTINSTANCE.wExponent;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetExponent( word pExponent )
{
fDIDEVICEOBJECTINSTANCE.wExponent = pExponent;
}
// --------------------------------------------------------------------------
// Property:    FFForceResolution
// Description: The FFForceResolution defines how many different force output 
//              levels the actuator associated with this object is capable of 
//              outputting. 
//              
//              A scale of 0 to 10,000 units represents the range of possible 
//              force values, from none at 0, up to maximum output at 10,000. 
//              
//              For example, if this property is 20, there are 20 possible 
//              levels of force output and thus changes in the actual force 
//              output will occur at each 500 unit increment in force value. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetFFForceResolution()
{
return fDIDEVICEOBJECTINSTANCE.dwFFForceResolution;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetFFForceResolution( dword pFFForceResolution )
{
fDIDEVICEOBJECTINSTANCE.dwFFForceResolution = pFFForceResolution;
}
// --------------------------------------------------------------------------
// Property:    FFMaxForce
// Description: The FFMaxForce property defines the maximum force, in 
//              newtons, the actuator associated with this object is capable 
//              of creating. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetFFMaxForce()
{
return fDIDEVICEOBJECTINSTANCE.dwFFMaxForce;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetFFMaxForce( dword pFFMaxForce )
{
fDIDEVICEOBJECTINSTANCE.dwFFMaxForce = pFFMaxForce;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating additional 
//              attributes of the device object instance. 
//              The described effect applies when the flag is set. 
// Flags:       DIDOI_ASPECTACCEL -
//                This device object instance can report acceleration 
//                information. 
//                
//              DIDOI_ASPECTFORCE -
//                This device object instance can report force information. 
//              DIDOI_ASPECTMASK -
//                This flag contains the bits that are used to report aspect 
//                information. 
//                
//                An object can only represent one aspect. 
//              DIDOI_ASPECTPOSITION -
//                This device object instance can report position 
//                information. 
//              DIDOI_ASPECTVELOCITY -
//                This device object instance can report velocity 
//                information. 
//              DIDOI_FFACTUATOR -
//                This device object instance is capable of applying force 
//                feedback effects. 
//              DIDOI_FFEFFECTTRIGGER -
//                The device object instance can trigger the playback of 
//                force feedback effects, which is useful when using 
//                condition effects. 
//              DIDOI_POLLED -
//                The device object instance must be polled to obtain data. 
//                
//                TDx_InputDevice::Poll() must be explicitly called in order 
//                to obtain data from the object. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetFlags()
{
return fDIDEVICEOBJECTINSTANCE.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetFlags( dword pFlags )
{
fDIDEVICEOBJECTINSTANCE.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    GuidType
// Description: The GuidType property defines a device type that describes 
//              this device object instance. 
//              
//              This property is optional and the possible values are: 
//              
//              GUID_XAxis       The horizontal axis. 
//              GUID_YAxis       The vertical axis. 
//              GUID_ZAxis       The z-axis. 
//              GUID_RxAxis     Rotation about the x-axis. 
//              GUID_RyAxis     Rotation about the y-axis. 
//              GUID_RzAxis     Rotation about the z-axis 
//              GUID_Slider       A slider axis. 
//              GUID_Button      A mouse button. 
//              GUID_Key          A keyboard key. 
//              GUID_POV         A point-of-view indicator or "hat". 
//              GUID_Unknown Unknown object. 
// --------------------------------------------------------------------------
GUID __fastcall TDIDeviceObjectInstance::FGetGuidType()
{
return fDIDEVICEOBJECTINSTANCE.guidType;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetGuidType( GUID pGuidType )
{
fDIDEVICEOBJECTINSTANCE.guidType = pGuidType;
}
// --------------------------------------------------------------------------
// Property:    Name
// Description: The Name property defines the friendly name of the object. 
//              
//              A friendly name will be something like 'Button 3' or 'Space 
//              Bar'. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIDeviceObjectInstance::FGetName()
{
AnsiString tempName = fDIDEVICEOBJECTINSTANCE.tszName;
return tempName;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetName( AnsiString pName )
{
int max = pName.Length();
if (max>MAX_PATH) max = MAX_PATH;

#ifdef _UNICODE
CopyMemory( &fDIDEVICEOBJECTINSTANCE.tszName[0], pName.c_str(), max*2 );
#else
CopyMemory( &fDIDEVICEOBJECTINSTANCE.tszName[0], pName.c_str(), max );
#endif
}
// --------------------------------------------------------------------------
// Property:    Ofs
// Description: The Ofs property defines the offset within the data format at 
//              which data is reported for this object. 
//              
//              This value can be used to identify the object in method calls 
//              and objects accepting the DIPH_BYOFFSET flag. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetOfs()
{
return fDIDEVICEOBJECTINSTANCE.dwOfs;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetOfs( dword pOfs )
{
fDIDEVICEOBJECTINSTANCE.dwOfs = pOfs;
}
// --------------------------------------------------------------------------
// Property:    ReportId
// Description: The ReportId property is reserved and should be set to 0. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetReportId()
{
return fDIDEVICEOBJECTINSTANCE.wReportId;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetReportId( word pReportId )
{
fDIDEVICEOBJECTINSTANCE.wReportId = pReportId;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
//              
//              This property may be inspected during enumeration to 
//              determine how many properties of the component are valid. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetSize()
{
return fDIDEVICEOBJECTINSTANCE.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetSize( dword pSize )
{
fDIDEVICEOBJECTINSTANCE.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Type
// Description: The Type property is unusual, in that it defines flags 
//              indicating the object type and it also identifies the object 
//              instance number in the middle 16 bits. 
//              
//              The object instance number can be extracted using the 
//              DIDFT_GETINSTANCE macro: 
//              
//                DIDFT_GETINSTANCE(n)   LOWORD((n) >> 8) 
//              
//              where n is one of the TDIDeviceObjectInstance::Type flag 
//              values. 
//              
//              The described effect applies when the flag is set. 
// Flags:       DIDFT_ABSAXIS -
//                Enumerate any object with an absolute axis. 
//              DIDFT_ALL -
//                Enumerate all objects. 
//              DIDFT_AXIS -
//                Enumerate any object with an absolute or relative axis. 
//              DIDFT_BUTTON -
//                Enumerate any object with push or toggle buttons. 
//              DIDFT_COLLECTION -
//                Enumerate HID link collections. 
//              DIDFT_ENUMCOLLECTION(n) -
//                Enumerate objects that belong to HID link collection number 
//                n. 
//              DIDFT_FFACTUATOR -
//                Enumerate objects to which force-feedback may be applied. 
//              DIDFT_FFEFFECTTRIGGER -
//                Enumerate objects that can trigger force-feedback effects. 
//              DIDFT_NOCOLLECTION -
//                Enumerate objects that do not belong to any HID link 
//                collection. 
//                Objects falling into this category are those that have 
//                TDIDeviceObjectInstance::CollectionNumber = 0. 
//              DIDFT_NODATA -
//                Enumerate objects that do not generate data. 
//              DIDFT_OUTPUT -
//                Enumerate objects to which data can be sent using 
//                TDx_InputDevice::SendDeviceData(). 
//              DIDFT_POV -
//                Enumerate point-of-view controllers. 
//              DIDFT_PSHBUTTON -
//                Enumerate push buttons. 
//                Push buttons is reported as down when pressed, and up when 
//                released. 
//              DIDFT_RELAXIS -
//                Enumerate objects with a relative axis.. 
//              DIDFT_TGLBUTTON -
//                Enumerate objects that are toggle buttons. 
//                Toggle buttons are reported down when pressed, and remain 
//                down until re-pressed.. 
//              DIDFT_VENDORDEFINED -
//                Enumerate objects of a type defined by the device 
//                manufacturer. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectInstance::FGetType()
{
return fDIDEVICEOBJECTINSTANCE.dwType;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetType( dword pType )
{
fDIDEVICEOBJECTINSTANCE.dwType = pType;
}
// --------------------------------------------------------------------------
// Property:    Usage
// Description: The Usage property defines the HID usage code. 
//              
//              Usage codes are optional for non-HID devices. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetUsage()
{
return fDIDEVICEOBJECTINSTANCE.wUsage;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetUsage( word pUsage )
{
fDIDEVICEOBJECTINSTANCE.wUsage = pUsage;
}
// --------------------------------------------------------------------------
// Property:    UsagePage
// Description: The UsagePage property defines the HID usage page code. 
//              
//              Usage page codes are optional for non-HID devices. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceObjectInstance::FGetUsagePage()
{
return fDIDEVICEOBJECTINSTANCE.wUsagePage;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetUsagePage( word pUsagePage )
{
fDIDEVICEOBJECTINSTANCE.wUsagePage = pUsagePage;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIDeviceObjectInstance's internal DIDEVICEOBJECTINSTANCE 
//              structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::Clear()
{
fDIDEVICEOBJECTINSTANCE.wCollectionNumber = 0;
fDIDEVICEOBJECTINSTANCE.wDesignatorIndex = 0;
fDIDEVICEOBJECTINSTANCE.dwDimension = 0;
fErrorValue = DI_OK;
fDIDEVICEOBJECTINSTANCE.wExponent = 0;
fDIDEVICEOBJECTINSTANCE.dwFFForceResolution = 0;
fDIDEVICEOBJECTINSTANCE.dwFFMaxForce = 0;
fDIDEVICEOBJECTINSTANCE.dwFlags = 0;
ZeroMemory(&fGuidType,sizeof(_GUID));
fDIDEVICEOBJECTINSTANCE.dwOfs = 0;
fDIDEVICEOBJECTINSTANCE.wReportId = 0;
fDIDEVICEOBJECTINSTANCE.dwSize = sizeof(DIDEVICEOBJECTINSTANCE);
fDIDEVICEOBJECTINSTANCE.dwType = 0;
fDIDEVICEOBJECTINSTANCE.wUsage = 0;
fDIDEVICEOBJECTINSTANCE.wUsagePage = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIDEVICEOBJECTINSTANCE* __fastcall TDIDeviceObjectInstance::FGetInternal_DIDEVICEOBJECTINSTANCE_Ptr()
{
return &fDIDEVICEOBJECTINSTANCE;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetInternal_DIDEVICEOBJECTINSTANCE( DIDEVICEOBJECTINSTANCE* pDIDEVICEOBJECTINSTANCE )
{
if (pDIDEVICEOBJECTINSTANCE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDeviceObjectInstance::FSetInternal_DIDEVICEOBJECTINSTANCE()", "TDX_ERROR", "The supplied DIDEVICEOBJECTINSTANCE* was NULL" );
    return;
    }

CopyMemory( &fDIDEVICEOBJECTINSTANCE, pDIDEVICEOBJECTINSTANCE, sizeof(DIDEVICEOBJECTINSTANCE) );
Internal_DIDEVICEOBJECTINSTANCE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::Internal_DIDEVICEOBJECTINSTANCE_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDIDeviceObjectInstance_Flags_Set<> of 
//              the flags in the current fDIDEVICEOBJECTINSTANCE.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIDeviceObjectInstance_Flags_Set __fastcall TDIDeviceObjectInstance::FGetFlags_()
{
TDIDeviceObjectInstance_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_FFACTUATOR) TempFlags_ = TempFlags_ << didoi_ffactuator;
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_FFEFFECTTRIGGER) TempFlags_ = TempFlags_ << didoi_ffeffecttrigger;
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_POLLED) TempFlags_ = TempFlags_ << didoi_polled;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetFlags_( TDIDeviceObjectInstance_Flags_Set pFlags_ )
{
fDIDEVICEOBJECTINSTANCE.dwFlags = 0;
if (pFlags_.Contains(didoi_ffactuator)) fDIDEVICEOBJECTINSTANCE.dwFlags |= DIDOI_FFACTUATOR;
if (pFlags_.Contains(didoi_ffeffecttrigger)) fDIDEVICEOBJECTINSTANCE.dwFlags |= DIDOI_FFEFFECTTRIGGER;
if (pFlags_.Contains(didoi_polled)) fDIDEVICEOBJECTINSTANCE.dwFlags |= DIDOI_POLLED;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIDeviceObjectInstance::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIDeviceObjectInstance::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_FFACTUATOR) fFlags_Strings->Add("DIDOI_FFACTUATOR");
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_FFEFFECTTRIGGER) fFlags_Strings->Add("DIDOI_FFEFFECTTRIGGER");
if (fDIDEVICEOBJECTINSTANCE.dwFlags & DIDOI_POLLED) fFlags_Strings->Add("DIDOI_POLLED");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetType_
// Description: This method returns a TDIDeviceObjectInstance_Type_Set<> of 
//              the flags in the current fDIDEVICEOBJECTINSTANCE.dwType. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIDeviceObjectInstance_Type_Set __fastcall TDIDeviceObjectInstance::FGetType_()
{
TDIDeviceObjectInstance_Type_Set TempType_;
TempType_.Clear();
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_ABSAXIS) TempType_ = TempType_ << didft_absaxis_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_ALL) TempType_ = TempType_ << didft_all;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_AXIS) TempType_ = TempType_ << didft_axis_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_BUTTON) TempType_ = TempType_ << didft_button_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_COLLECTION) TempType_ = TempType_ << didft_collection;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_FFACTUATOR) TempType_ = TempType_ << didft_ffactuator_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_FFEFFECTTRIGGER) TempType_ = TempType_ << didft_ffeffecttrigger_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_NOCOLLECTION) TempType_ = TempType_ << didft_nocollection;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_NODATA) TempType_ = TempType_ << didft_nodata;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_OUTPUT) TempType_ = TempType_ << didft_output;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_POV) TempType_ = TempType_ << didft_pov_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_PSHBUTTON) TempType_ = TempType_ << didft_pshbutton_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_RELAXIS) TempType_ = TempType_ << didft_relaxis_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_TGLBUTTON) TempType_ = TempType_ << didft_tglbutton_;
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_VENDORDEFINED) TempType_ = TempType_ << didft_vendordefined_;
return TempType_;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectInstance::FSetType_( TDIDeviceObjectInstance_Type_Set pType_ )
{
fDIDEVICEOBJECTINSTANCE.dwType = 0;
if (pType_.Contains(didft_absaxis_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_ABSAXIS;
if (pType_.Contains(didft_all)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_ALL;
if (pType_.Contains(didft_axis_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_AXIS;
if (pType_.Contains(didft_button_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_BUTTON;
if (pType_.Contains(didft_collection)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_COLLECTION;
if (pType_.Contains(didft_ffactuator_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_FFACTUATOR;
if (pType_.Contains(didft_ffeffecttrigger_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_FFEFFECTTRIGGER;
if (pType_.Contains(didft_nocollection)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_NOCOLLECTION;
if (pType_.Contains(didft_nodata)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_NODATA;
if (pType_.Contains(didft_output)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_OUTPUT;
if (pType_.Contains(didft_pov_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_POV;
if (pType_.Contains(didft_pshbutton_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_PSHBUTTON;
if (pType_.Contains(didft_relaxis_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_RELAXIS;
if (pType_.Contains(didft_tglbutton_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_TGLBUTTON;
if (pType_.Contains(didft_vendordefined_)) fDIDEVICEOBJECTINSTANCE.dwType |= DIDFT_VENDORDEFINED;
}
// --------------------------------------------------------------------------
// Method:      FGetType_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Type' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIDeviceObjectInstance::FGetType_Strings()
{
// if the strings have not been allocated
if (fType_Strings==NULL)
    {
    // attempt to allocate the strings
    fType_Strings = new TStringList();
    // if the allocation failed
    if (fType_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIDeviceObjectInstance::FGetType_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Type_Strings" );
        return NULL;
        }
    }
fType_Strings->Clear();
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_ABSAXIS) fType_Strings->Add("DIDFT_ABSAXIS");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_ALL) fType_Strings->Add("DIDFT_ALL");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_AXIS) fType_Strings->Add("DIDFT_AXIS");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_BUTTON) fType_Strings->Add("DIDFT_BUTTON");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_COLLECTION) fType_Strings->Add("DIDFT_COLLECTION");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_FFACTUATOR) fType_Strings->Add("DIDFT_FFACTUATOR");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_FFEFFECTTRIGGER) fType_Strings->Add("DIDFT_FFEFFECTTRIGGER");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_NOCOLLECTION) fType_Strings->Add("DIDFT_NOCOLLECTION");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_NODATA) fType_Strings->Add("DIDFT_NODATA");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_OUTPUT) fType_Strings->Add("DIDFT_OUTPUT");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_POV) fType_Strings->Add("DIDFT_POV");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_PSHBUTTON) fType_Strings->Add("DIDFT_PSHBUTTON");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_RELAXIS) fType_Strings->Add("DIDFT_RELAXIS");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_TGLBUTTON) fType_Strings->Add("DIDFT_TGLBUTTON");
if (fDIDEVICEOBJECTINSTANCE.dwType & DIDFT_VENDORDEFINED) fType_Strings->Add("DIDFT_VENDORDEFINED");
return fType_Strings;
}
// --------------------------------------------------------------------------
