// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIEffEscape.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIEffEscape Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIEffEscape.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIEffEscape*)
{
    new TDIEffEscape(NULL);
}
// --------------------------------------------------------------------------
namespace Tdieffescape
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIEffEscape)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIEffEscape::TDIEffEscape()
// Description: The default constructor for the TDIEffEscape object.
// --------------------------------------------------------------------------
__fastcall TDIEffEscape::TDIEffEscape(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIEffEscape::~TDIEffEscape()
// Description: The destructor for the TDIEffEscape object.
// --------------------------------------------------------------------------
__fastcall TDIEffEscape::~TDIEffEscape()
{
}
// --------------------------------------------------------------------------
// Property:    Command
// Description: The Command property defines which command is being sent to 
//              the driver. 
//              
//              The driver documentation should list valid comand numbers and 
//              their associated function. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffEscape::FGetCommand()
{
return fDIEFFESCAPE.dwCommand;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetCommand( dword pCommand )
{
fDIEFFESCAPE.dwCommand = pCommand;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIEffEscape method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIEffEscape::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    InBuffer
// Description: The InBuffer property references a buffer with the data 
//              required to perform the requested operation. 
// --------------------------------------------------------------------------
void* __fastcall TDIEffEscape::FGetInBuffer()
{
return fDIEFFESCAPE.lpvInBuffer;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetInBuffer( void* pInBuffer )
{
fDIEFFESCAPE.lpvInBuffer = pInBuffer;
}
// --------------------------------------------------------------------------
// Property:    InBufferSize
// Description: The InBufferSize property defines the size, in bytes, of the 
//              buffer referenced by TDIEffEscape::InBuffer. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffEscape::FGetInBufferSize()
{
return fDIEFFESCAPE.cbInBuffer;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetInBufferSize( dword pInBufferSize )
{
fDIEFFESCAPE.cbInBuffer = pInBufferSize;
}
// --------------------------------------------------------------------------
// Property:    OutBuffer
// Description: The OutBuffer property references a buffer for holding data 
//              returned by the requested operation. 
// --------------------------------------------------------------------------
void* __fastcall TDIEffEscape::FGetOutBuffer()
{
return fDIEFFESCAPE.lpvOutBuffer;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetOutBuffer( void* pOutBuffer )
{
fDIEFFESCAPE.lpvOutBuffer = pOutBuffer;
}
// --------------------------------------------------------------------------
// Property:    OutBufferSize
// Description: The OutBufferSize property defines the size, in bytes, of the 
//              buffer referenced by TDIEffEscape::OutBuffer when calling the 
//              escape methods and indicates how many bytes were actually 
//              written on returning. 
//              
//              The application should make sure the buffer is big enough for 
//              the actual amount of output. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffEscape::FGetOutBufferSize()
{
return fDIEFFESCAPE.cbOutBuffer;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetOutBufferSize( dword pOutBufferSize )
{
fDIEFFESCAPE.cbOutBuffer = pOutBufferSize;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffEscape::FGetSize()
{
return fDIEFFESCAPE.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetSize( dword pSize )
{
fDIEFFESCAPE.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIEffEscape's internal DIEFFESCAPE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::Clear()
{
fDIEFFESCAPE.dwCommand = 0;
fErrorValue = DI_OK;
fDIEFFESCAPE.lpvInBuffer = NULL;
fDIEFFESCAPE.cbInBuffer = 0;
fDIEFFESCAPE.lpvOutBuffer = NULL;
fDIEFFESCAPE.cbOutBuffer = 0;
fDIEFFESCAPE.dwSize = sizeof(DIEFFESCAPE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIEFFESCAPE* __fastcall TDIEffEscape::FGetInternal_DIEFFESCAPE_Ptr()
{
return &fDIEFFESCAPE;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::FSetInternal_DIEFFESCAPE( DIEFFESCAPE* pDIEFFESCAPE )
{
if (pDIEFFESCAPE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIEffEscape::FSetInternal_DIEFFESCAPE()", "TDX_ERROR", "The supplied DIEFFESCAPE* was NULL" );
    return;
    }

CopyMemory( &fDIEFFESCAPE, pDIEFFESCAPE, sizeof(DIEFFESCAPE) );
Internal_DIEFFESCAPE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIEffEscape::Internal_DIEFFESCAPE_Update()
{
}

// --------------------------------------------------------------------------
