// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIEffect.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIEffect Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIEffect.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIEffect*)
{
    new TDIEffect(NULL);
}
// --------------------------------------------------------------------------
namespace Tdieffect
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIEffect)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIEffect::TDIEffect()
// Description: The default constructor for the TDIEffect object.
// --------------------------------------------------------------------------
__fastcall TDIEffect::TDIEffect(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDIEffect::~TDIEffect()
// Description: The destructor for the TDIEffect object.
// --------------------------------------------------------------------------
__fastcall TDIEffect::~TDIEffect()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    Axes
// Description: The Axes property references an array of TDIEffect::AxesCount 
//              DWORD's identifying which axes the effect is to be applied 
//              to. 
//              
//              The setting of DIEFF_OBJECTIDS or DIEFF_OBJECTOFFSETS in 
//              TDIEffect::Flags will determine how the values contained in 
//              the array are interpreted. 
//              
//              Up to 32 axes may be associated with a single effect, but the 
//              list cannot be changed once it has been set. 
// --------------------------------------------------------------------------
dword* __fastcall TDIEffect::FGetAxes()
{
return fDIEFFECT.rgdwAxes;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetAxes( dword* pAxes )
{
fDIEFFECT.rgdwAxes = pAxes;
}
// --------------------------------------------------------------------------
// Property:    AxesCount
// Description: The AxesCount property defines the number of axes involved in 
//              this effect. 
//              
//              A value must be set for this property when changing the axis 
//              or direction lists and the number of axes for an effect 
//              cannot be changed once set. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetAxesCount()
{
return fDIEFFECT.cAxes;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetAxesCount( dword pAxesCount )
{
fDIEFFECT.cAxes = pAxesCount;
}
// --------------------------------------------------------------------------
// Property:    Direction
// Description: The Direction property references an array of 
//              TDIEffect::AxesCount LONG's containing either cartesian, 
//              polar or spherical coordinates. 
//              
//              The setting of DIEFF_CARTESIAN, DIEFF_POLAR or 
//              DIEFF_SPHERICAL in TDIEffect::Flags will determine how the 
//              values contained in the array are interpreted. 
//              
//              Each value in the Direction array will be associated with the 
//              corresponding value in the TDIEffect::Axes array for 
//              cartesian coordinates. 
//              
//              Polar and spherical coordinates require one less element than 
//              cartesian coordinates to indicate direction but the Direction 
//              array must still contain TDIEffect::AxesCount elements, with 
//              the last element set to zero. 
// --------------------------------------------------------------------------
long* __fastcall TDIEffect::FGetDirection()
{
return fDIEFFECT.rglDirection;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetDirection( long* pDirection )
{
fDIEFFECT.rglDirection = pDirection;
}
// --------------------------------------------------------------------------
// Property:    Duration
// Description: The Duration property defines the total duration, in 
//              microseconds, the effect should be active. 
//              
//              This property can be set to INFINITE in which case the effect 
//              has infinite duration. If there is an envelope 
//              then the attack will be applied, followed by an infinite 
//              sustain. 
//              
//              The INFINITE setting is most frequently used for conditions 
//              since they respond to device motion rather explicit effect 
//              calls. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetDuration()
{
return fDIEFFECT.dwDuration;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetDuration( dword pDuration )
{
fDIEFFECT.dwDuration = pDuration;
}
// --------------------------------------------------------------------------
// Property:    Envelope
// Description: The Envelope property references a TDIEnvelope component 
//              defining the envelope to be used by the effect.   
//              
//              Not all effect types can use envelopes and if there is no 
//              envelope, this property should be NULL. 
// --------------------------------------------------------------------------
TDIEnvelope* __fastcall TDIEffect::FGetEnvelope()
{
if (ComponentState.Contains(csDesigning) &&
    (fEnvelope!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fEnvelope)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fEnvelope=NULL;
    }
return fEnvelope;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetEnvelope( TDIEnvelope* pEnvelope )
{
fEnvelope = pEnvelope;
fDIEFFECT.lpEnvelope = pEnvelope->Internal_DIENVELOPE_Ptr;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIEffect method or fget/fset. eg. 
//              DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIEffect::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating which coordinate 
//              system and axis interpretation should be used. 
//              The described effect applies when the flag is set. 
// Flags:       DIEFF_CARTESIAN -
//                The contents of the array referenced by 
//                TDIEffect::Direction should be interpreted as cartesian 
//                coordinates. 
//              DIEFF_OBJECTIDS -
//                The contents of the arrays referenced by TDIEffect::Axes 
//                and TDIEffect::TriggerButton should be interpreted as 
//                object identifiers like those returned by 
//                TDx_InputDevice::EnumObjects(). 
//              DIEFF_OBJECTOFFSETS -
//                The contents of the arrays referenced by TDIEffect::Axes 
//                and TDIEffect::TriggerButton should be interpreted as 
//                offsets into the data format selected using 
//                TDx_InputDevice::SetDataFormat(). 
//              DIEFF_POLAR -
//                The contents of the array referenced by 
//                TDIEffect::Direction should be interpreted as polar 
//                coordinates. 
//              DIEFF_SPHERICAL -
//                The contents of the array referenced by 
//                TDIEffect::Direction should be interpreted as spherical 
//                coordinates. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetFlags()
{
return fDIEFFECT.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetFlags( dword pFlags )
{
fDIEFFECT.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Gain
// Description: The Gain property defines the gain to be applied to the 
//              effect. 
//              
//              This value represents no force output at 0 and normal force 
//              output at 10,000. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetGain()
{
return fDIEFFECT.dwGain;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetGain( dword pGain )
{
fDIEFFECT.dwGain = pGain;
}
// --------------------------------------------------------------------------
// Property:    SamplePeriod
// Description: The SamplePeriod property defines the sample period, in 
//              microseconds, the device should use to play back the effect. 
//              
//              A setting of 0 results in the default sample period being 
//              used and an unsupported rate will be rounded to the closest 
//              setting the device can support. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetSamplePeriod()
{
return fDIEFFECT.dwSamplePeriod;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetSamplePeriod( dword pSamplePeriod )
{
fDIEFFECT.dwSamplePeriod = pSamplePeriod;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetSize()
{
return fDIEFFECT.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetSize( dword pSize )
{
fDIEFFECT.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    StartDelay
// Description: The StartDelay property defines how long, in microseconds, to 
//              wait after the TDx_InputEffect::Start() call is made before 
//              playing the effect. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetStartDelay()
{
return fDIEFFECT.dwStartDelay;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetStartDelay( dword pStartDelay )
{
fDIEFFECT.dwStartDelay = pStartDelay;
}
// --------------------------------------------------------------------------
// Property:    TriggerButton
// Description: The TriggerButton property indicates which button should 
//              trigger the effect's playback. 
//              
//              A setting of DIEB_NOTRIGGER indicates that the effect is not 
//              triggered by a button and the setting of DIEFF_OBJECTIDS or 
//              DIEFF_OBJECTOFFSETS in TDIEffect::Flags determines how this 
//              value is interpreted. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetTriggerButton()
{
return fDIEFFECT.dwTriggerButton;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetTriggerButton( dword pTriggerButton )
{
fDIEFFECT.dwTriggerButton = pTriggerButton;
}
// --------------------------------------------------------------------------
// Property:    TriggerRepeatInterval
// Description: The TriggerRepeatInterval property defines the how long, in 
//              microseconds, to wait between playbacks of the effect when 
//              the button is held down. 
//              
//              This property is only used if the effect is triggered by a 
//              button press and repetition support is available. 
//              Repetition support will be indicated by the 
//              DIEP_TRIGGERREPEATINTERVAL flag being set in the 
//              TDIEffectInfo::StaticParams associated with this effect. 
//              
//              A setting of INFINITE indicates there will be no effect 
//              repetition while the button is held down. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetTriggerRepeatInterval()
{
return fDIEFFECT.dwTriggerRepeatInterval;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetTriggerRepeatInterval( dword pTriggerRepeatInterval )
{
fDIEFFECT.dwTriggerRepeatInterval = pTriggerRepeatInterval;
}
// --------------------------------------------------------------------------
// Property:    TypeSpecificParams
// Description: The TypeSpecificParams property references the internal 
//              structure of the appropriate TDICustomForce, TDIPeriodic, 
//              TDIConstantForce, TDIRampForce or TDICondition component, 
//              which in turn provide additional parameters appropriate to 
//              the effect type. 
//              
//              NULL may be set when the effect has no type specific 
//              parameters. 
//              
//              The TDIEffectInfo::EffectType property defines the effect 
//              type :- DIEFT_CONDITION, DIEFT_CONSTANTFORCE, 
//              DIEFT_CUSTOMFORCE, DIEFT_PERIODIC or DIEFT_RAMPFORCE. 
//              
//              For DIEFT_CONDITION effects, this property should reference 
//              the internal array of DICONDITION structures referenced by 
//              the TDICondition::Internal_DICONDITION_Ptr property. 
//              
//              For example: 
//              
//                  void __fastcall TForm1::Button1Click(TObject* Sender) 
//                  { 
//                  // set multiwrapper to contain 5 x DICONDITION 
//              structures. 
//                  DICondition1->ArraySize = 5; 
//                  . 
//                  . 
//                  . 
//                  // set effect type 
//                  DIEffectInfo1->EffectType = DIEFT_CONDITION; 
//              
//                  // set the array size 
//                  DIEffect1->TypeSpecificParamsSize = 5 * 
//              DICondition1->Size; 
//                  // or you could set it like this 
//                  DIEffect1->TypeSpecificParamsSize = 
//              DICondition1->SizeAll; 
//                  // or even like this 
//                  DIEffect1->TypeSpecificParamsSize = 
//              5*sizeof(DICONDITION); 
//              
//                  // point to first of the internal DICONDITION structures 
//              in the DICondition1 component 
//                  DIEffect1->TypeSpecificParams = 
//              DICondition1->Internal_DICONDITION_Ptr[0]; 
//                  } 
//              
//              When only one condition is being used the direction will be 
//              obtained from TDIEffect::Direction. Otherwise, there must be 
//              one internal DICONDITION structure for each axis affected, in 
//              the same order as TDIEffect::Axes, the effect should not be 
//              rotated and the following values used in the 
//              TDIEffect::Direction array: 
//              
//                  Spherical coordinates : 0, 0, etc 
//                  Polar coordinates : 9000, 0, etc 
//                  Cartesian coordinates 1, 0, etc 
//              
//              When using the other effect types, this property should 
//              reference the internal structure of the appropriate wrapper 
//              component. 
//              
//              For example: 
//              
//                  void __fastcall TForm1::Button1Click(TObject* Sender) 
//                  { 
//                  // set effect type 
//                  DIEffectInfo1->EffectType = DIEFT_CONSTANTFORCE; 
//                 // set the size 
//                  DIEffect1->TypeSpecificParamsSize = 
//              DIConstantForce1->Size; 
//                  // point to the internal DICONSTANTFORCE structure of 
//              DIConstantForce1 
//                  DIEffect1->TypeSpecificParams = 
//              DIConstantForce1->Internal_DICONSTANTFORCE_Ptr; 
//                  } 
// --------------------------------------------------------------------------
void* __fastcall TDIEffect::FGetTypeSpecificParams()
{
return fDIEFFECT.lpvTypeSpecificParams;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetTypeSpecificParams( void* pTypeSpecificParams )
{
fDIEFFECT.lpvTypeSpecificParams = pTypeSpecificParams;
}
// --------------------------------------------------------------------------
// Property:    TypeSpecificParamsSize
// Description: The TypeSpecificParamsSize property defines total size, in 
//              bytes, of the parameters referenced by 
//              TDIEffect::TypeSpecificParams. Refer to the 
//              TDIEffect::TypeSpecificParams property for examples of how to 
//              calculate this value. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffect::FGetTypeSpecificParamsSize()
{
return fDIEFFECT.cbTypeSpecificParams;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetTypeSpecificParamsSize( dword pTypeSpecificParamsSize )
{
fDIEFFECT.cbTypeSpecificParams = pTypeSpecificParamsSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIEffect's internal DIEFFECT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIEffect::Clear()
{
fDIEFFECT.rgdwAxes = NULL;
fDIEFFECT.cAxes = 0;
fDIEFFECT.rglDirection = NULL;
fDIEFFECT.dwDuration = 0;
fEnvelope = NULL;
fDIEFFECT.lpEnvelope = NULL;
fErrorValue = DI_OK;
fDIEFFECT.dwFlags = 0;
fDIEFFECT.dwGain = 0;
fDIEFFECT.dwSamplePeriod = 0;
fDIEFFECT.dwSize = sizeof(DIEFFECT);
fDIEFFECT.dwStartDelay = 0;
fDIEFFECT.dwTriggerButton = 0;
fDIEFFECT.dwTriggerRepeatInterval = 0;
fDIEFFECT.lpvTypeSpecificParams = NULL;
fDIEFFECT.cbTypeSpecificParams = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIEFFECT* __fastcall TDIEffect::FGetInternal_DIEFFECT_Ptr()
{
return &fDIEFFECT;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetInternal_DIEFFECT( DIEFFECT* pDIEFFECT )
{
if (pDIEFFECT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIEffect::FSetInternal_DIEFFECT()", "TDX_ERROR", "The supplied DIEFFECT* was NULL" );
    return;
    }

CopyMemory( &fDIEFFECT, pDIEFFECT, sizeof(DIEFFECT) );
Internal_DIEFFECT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::Internal_DIEFFECT_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDIEffect_Flags_Set<> of the flags in 
//              the current fDIEFFECT.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIEffect_Flags_Set __fastcall TDIEffect::FGetFlags_()
{
TDIEffect_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDIEFFECT.dwFlags & DIEFF_CARTESIAN) TempFlags_ = TempFlags_ << dieff_cartesian;
if (fDIEFFECT.dwFlags & DIEFF_OBJECTIDS) TempFlags_ = TempFlags_ << dieff_objectids;
if (fDIEFFECT.dwFlags & DIEFF_OBJECTOFFSETS) TempFlags_ = TempFlags_ << dieff_objectoffsets;
if (fDIEFFECT.dwFlags & DIEFF_POLAR) TempFlags_ = TempFlags_ << dieff_polar;
if (fDIEFFECT.dwFlags & DIEFF_SPHERICAL) TempFlags_ = TempFlags_ << dieff_spherical;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffect::FSetFlags_( TDIEffect_Flags_Set pFlags_ )
{
fDIEFFECT.dwFlags = 0;
if (pFlags_.Contains(dieff_cartesian)) fDIEFFECT.dwFlags |= DIEFF_CARTESIAN;
if (pFlags_.Contains(dieff_objectids)) fDIEFFECT.dwFlags |= DIEFF_OBJECTIDS;
if (pFlags_.Contains(dieff_objectoffsets)) fDIEFFECT.dwFlags |= DIEFF_OBJECTOFFSETS;
if (pFlags_.Contains(dieff_polar)) fDIEFFECT.dwFlags |= DIEFF_POLAR;
if (pFlags_.Contains(dieff_spherical)) fDIEFFECT.dwFlags |= DIEFF_SPHERICAL;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIEffect::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIEffect::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDIEFFECT.dwFlags & DIEFF_CARTESIAN) fFlags_Strings->Add("DIEFF_CARTESIAN");
if (fDIEFFECT.dwFlags & DIEFF_OBJECTIDS) fFlags_Strings->Add("DIEFF_OBJECTIDS");
if (fDIEFFECT.dwFlags & DIEFF_OBJECTOFFSETS) fFlags_Strings->Add("DIEFF_OBJECTOFFSETS");
if (fDIEFFECT.dwFlags & DIEFF_POLAR) fFlags_Strings->Add("DIEFF_POLAR");
if (fDIEFFECT.dwFlags & DIEFF_SPHERICAL) fFlags_Strings->Add("DIEFF_SPHERICAL");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
