// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIFileEffect.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIFileEffect Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIFileEffect.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIFileEffect*)
{
    new TDIFileEffect(NULL);
}
// --------------------------------------------------------------------------
namespace Tdifileeffect
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIFileEffect)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIFileEffect::TDIFileEffect()
// Description: The default constructor for the TDIFileEffect object.
// --------------------------------------------------------------------------
__fastcall TDIFileEffect::TDIFileEffect(TComponent* Owner)
    : TComponent(Owner)
{
fDIFILEEFFECT=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TDIFileEffect::~TDIFileEffect()
// Description: The destructor for the TDIFileEffect object.
// --------------------------------------------------------------------------
__fastcall TDIFileEffect::~TDIFileEffect()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DIFILEEFFECT structures wrapped inside the TDIFileEffect 
//              component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDIFileEffect component wraps a single DIFILEEFFECT 
//              structure. To wrap multiple structures, set the 
//              TDIFileEffect::ArraySize to the total number of internal 
//              structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDIFileEffect::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDIFILEEFFECT;
    fDIFILEEFFECT = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDIFILEEFFECT = new DIFILEEFFECT[pArraySize];
    if (fDIFILEEFFECT==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIFILEEFFECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DIFILEEFFECT structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DIFILEEFFECT* temp_DIFILEEFFECT = new DIFILEEFFECT[pArraySize];
        if (temp_DIFILEEFFECT==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDIFILEEFFECT::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DIFILEEFFECT structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DIFILEEFFECT[fArraySize], sizeof(DIFILEEFFECT)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DIFILEEFFECT[0], &fDIFILEEFFECT[0], sizeof(DIFILEEFFECT)*fArraySize);
        // de-allocate old memory
        delete[] fDIFILEEFFECT;
        // re-assign the new memory
        fDIFILEEFFECT = temp_DIFILEEFFECT;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DIFILEEFFECT* temp_DIFILEEFFECT = new DIFILEEFFECT[pArraySize];
            if (temp_DIFILEEFFECT==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDIFILEEFFECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DIFILEEFFECT structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DIFILEEFFECT[0], &fDIFILEEFFECT[0], sizeof(DIFILEEFFECT)*pArraySize);
            // de-allocate the old memory
            delete[] fDIFILEEFFECT;
            // re-assign the new memory
            fDIFILEEFFECT = temp_DIFILEEFFECT;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Effect
// Description: The Effect property references a TDIEffect component holding 
//              the effect information. 
// --------------------------------------------------------------------------
TDIEffect* __fastcall TDIFileEffect::FGetEffect( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetEffect()", "TDX_ERROR", "Internal Array size is 0.");
     return (TDIEffect*) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetEffect()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (TDIEffect*) NULL;
    }

if (fDIFILEEFFECT[pArrayIndex].lpDiEffect!=NULL)
    {
    if (fEffect==NULL) fEffect = new TDIEffect(this);
    if (fEffect==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError( this, "TDIFileEffect::FGetEffect()", "TDX_ERROR", "Cannot allocate memory for internal TDIEffect storage.");
        return NULL;
        }
    CopyMemory( fEffect->Internal_DIEFFECT_Ptr, fDIFILEEFFECT[pArrayIndex].lpDiEffect, sizeof(DIEFFECT) );
    fEffect->Internal_DIEFFECT_Update();
    }
return fEffect;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetEffect( dword pArrayIndex, TDIEffect* pEffect )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetEffect()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetEffect()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

if (pEffect==NULL) fEffect = new TDIEffect(this);
if (pEffect==NULL)
    {
    fEffect = NULL;
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetEffect()", "TDX_ERROR", "Cannot allocate memory for internal TDIEffect storage.");
    return;
    }

fEffect = pEffect;
fDIFILEEFFECT[pArrayIndex].lpDiEffect = pEffect->Internal_DIEFFECT_Ptr;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIFileEffect method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIFileEffect::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FriendlyName
// Description: The FriendlyName property defines a friendly name for the 
//              effect such as 'Sawtooth up' or 'Constant force'. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIFileEffect::FGetFriendlyName( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetFriendlyName()", "TDX_ERROR", "Internal Array size is 0.");
     return (AnsiString) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetFriendlyName()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (AnsiString) NULL;
    }

AnsiString tempFriendlyName = fDIFILEEFFECT[pArrayIndex].szFriendlyName;
return tempFriendlyName;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetFriendlyName( dword pArrayIndex, AnsiString pFriendlyName )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetFriendlyName()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetFriendlyName()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

int max = pFriendlyName.Length();
if (max>MAX_PATH) max = MAX_PATH;
CopyMemory( &fDIFILEEFFECT[pArrayIndex].szFriendlyName[0], pFriendlyName.c_str(), max );
}
// --------------------------------------------------------------------------
// Property:    GuidEffect
// Description: The GuidEffect property identifies the effect type. 
//              
//              This may be one of the standard GUIDs listed below, or one 
//              created by the effects designer. 
//              
//              GUID_ConstantForce 
//              GUID_RampForce 
//              GUID_Square 
//              GUID_Sine 
//              GUID_Triangle 
//              GUID_SawtoothUp 
//              GUID_SawtoothDown 
//              GUID_Spring 
//              GUID_Damper 
//              GUID_Inertia 
//              GUID_Friction 
//              GUID_CustomForce 
// --------------------------------------------------------------------------
GUID __fastcall TDIFileEffect::FGetGuidEffect( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetGuidEffect()", "TDX_ERROR", "Internal Array size is 0.");
    return fGuidEffect;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetGuidEffect()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return fGuidEffect;
    }

return fDIFILEEFFECT[pArrayIndex].GuidEffect;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetGuidEffect( dword pArrayIndex, GUID pGuidEffect )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetGuidEffect()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetGuidEffect()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIFILEEFFECT[pArrayIndex].GuidEffect = pGuidEffect;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal DIFILEEFFECT structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIFileEffect::FGetSize( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetSize()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FGetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDIFILEEFFECT[pArrayIndex].dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetSize( dword pArrayIndex, dword pSize )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetSize()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::FSetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIFILEEFFECT[pArrayIndex].dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DIFILEEFFECT structures. This result is the same as 
//              multiplying TDIFileEffect::ArraySize and TDIFileEffect::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDIFileEffect::FGetSizeAll()
{
dword temp = 0;
for (dword i=0;i<fArraySize;i++) temp += fDIFILEEFFECT[i].dwSize;
return temp;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIFileEffect's internal DIFILEEFFECT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDIFileEffect::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDIFILEEFFECT[pArrayIndex], sizeof(DIFILEEFFECT) );
fDIFILEEFFECT[pArrayIndex].dwSize = sizeof(DIFILEEFFECT);
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DIFILEEFFECT structures of the TDIFileEffect 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIFileEffect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDIFILEEFFECT[0], sizeof(DIFILEEFFECT)*fArraySize );
for (dword i=0;i<fArraySize;i++) fDIFILEEFFECT[i].dwSize = sizeof(DIFILEEFFECT);
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DIFILEEFFECT* __fastcall TDIFileEffect::FGetInternal_DIFILEEFFECT_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIFileEffect::FGetInternal_DIFILEEFFECT_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDIFILEEFFECT;
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::FSetInternal_DIFILEEFFECT( dword pArrayIndex, DIFILEEFFECT* pDIFILEEFFECT )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIFileEffect::FSetInternal_DIFILEEFFECT()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDIFILEEFFECT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIFileEffect::FSetInternal_DIFILEEFFECT()", "TDX_ERROR", "The supplied DIFILEEFFECT* was NULL" );
    return;
    }
CopyMemory( &fDIFILEEFFECT[pArrayIndex], pDIFILEEFFECT, sizeof(DIFILEEFFECT) );
Internal_DIFILEEFFECT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIFileEffect::Internal_DIFILEEFFECT_Update()
{
}

// --------------------------------------------------------------------------
