// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIJoyState.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIJoyState Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIJoyState.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIJoyState*)
{
    new TDIJoyState(NULL);
}
// --------------------------------------------------------------------------
namespace Tdijoystate
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIJoyState)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIJoyState::TDIJoyState()
// Description: The default constructor for the TDIJoyState object.
// --------------------------------------------------------------------------
__fastcall TDIJoyState::TDIJoyState(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIJoyState::~TDIJoyState()
// Description: The destructor for the TDIJoyState object.
// --------------------------------------------------------------------------
__fastcall TDIJoyState::~TDIJoyState()
{
}
// --------------------------------------------------------------------------
// Property:    Buttons
// Description: The Buttons property defines a byte array of up to 32 button 
//              states. 
//              
//              When a given button is down, the high-order bit of the 
//              corresponding byte will be set. 
//              If the button is up, or does not exist, the bit will be 
//              clear. 
// --------------------------------------------------------------------------
byte __fastcall TDIJoyState::FGetButtons( dword pIndex )
{
if (pIndex>=32)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState::FGetButtons()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (BYTE) NULL;
    }
return fDIJOYSTATE.rgbButtons[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetButtons( dword pIndex, byte pButtons )
{
fDIJOYSTATE.rgbButtons[pIndex] = pButtons;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIJoyState method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIJoyState::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    POV
// Description: The POV property defines a dword array indicating the 
//              position, in 100ths of a degree, of up to 4 direction 
//              controllers such as a Point Of View hat. 
//              
//              Direction is measured clockwise from directly away from the 
//              user and the centered position is reported as -1 or 65535. 
//              
//              Thus, for an indicator with five positions, it could have a 
//              value of -1(or 65535) (centered), 0 (away from user), 9,000 
//              (to the right), 18,000 (towards the user), or 27,000 (to the 
//              left). 
// --------------------------------------------------------------------------
dword __fastcall TDIJoyState::FGetPOV( dword pIndex )
{
if (pIndex>=4)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState::FGetPOV()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (DWORD) NULL;
    }
return fDIJOYSTATE.rgdwPOV[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetPOV( dword pIndex, dword pPOV )
{
fDIJOYSTATE.rgdwPOV[pIndex] = pPOV;
}
// --------------------------------------------------------------------------
// Property:    RX
// Description: The RX property describes rotation of the joysticks X axis. 
//              
//              When rotation is unsupported, this property will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetRX()
{
return fDIJOYSTATE.lRx;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetRX( long pRX )
{
fDIJOYSTATE.lRx = pRX;
}
// --------------------------------------------------------------------------
// Property:    RY
// Description: The RY property describes rotation of the joysticks Y axis. 
//              
//              When rotation is unsupported, this property will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetRY()
{
return fDIJOYSTATE.lRy;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetRY( long pRY )
{
fDIJOYSTATE.lRy = pRY;
}
// --------------------------------------------------------------------------
// Property:    RZ
// Description: The RZ property describes rotation of the joysticks Z axis 
//              and is often called the rudder. 
//              
//              When rotation is unsupported or the Z axis does not exist, 
//              this property will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetRZ()
{
return fDIJOYSTATE.lRz;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetRZ( long pRZ )
{
fDIJOYSTATE.lRz = pRZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIJOYSTATE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIJoyState::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Slider
// Description: The Slider property defines an long array describing two 
//              additional axis values whose semantics depend on the specific 
//              joystick being used. 
//              
//              TDx_InputDevice::GetObjectInfo() can be used to obtain 
//              semantic information about these axes, which were formally 
//              called the U and V axes. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetSlider( dword pIndex )
{
if (pIndex>=2)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState::FGetSlider()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (LONG) NULL;
    }
return fDIJOYSTATE.rglSlider[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetSlider( dword pIndex, long pSlider )
{
fDIJOYSTATE.rglSlider[pIndex] = pSlider;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property describes movement of the joysticks X axis, 
//              which usually represents the left right movement of a control 
//              stick. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetX()
{
return fDIJOYSTATE.lX;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetX( long pX )
{
fDIJOYSTATE.lX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property describes movement of the joysticks Y axis, 
//              which usually represents the forward backward movement of a 
//              control stick. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetY()
{
return fDIJOYSTATE.lY;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetY( long pY )
{
fDIJOYSTATE.lY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property describes movement of the joysticks Z axis, 
//              which usually represents a throttle control. 
//              
//              When there is no Z axis, this property will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState::FGetZ()
{
return fDIJOYSTATE.lZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetZ( long pZ )
{
fDIJOYSTATE.lZ = pZ;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIJoyState's internal DIJOYSTATE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::Clear()
{
for (int Buttons_index=0;Buttons_index<32;Buttons_index++) fDIJOYSTATE.rgbButtons[Buttons_index] = 0;
fErrorValue = DI_OK;
for (int POV_index=0;POV_index<4;POV_index++) fDIJOYSTATE.rgdwPOV[POV_index] = 0;
fDIJOYSTATE.lRx = 0;
fDIJOYSTATE.lRy = 0;
fDIJOYSTATE.lRz = 0;
fSize = sizeof(DIJOYSTATE);
for (int Slider_index=0;Slider_index<2;Slider_index++) fDIJOYSTATE.rglSlider[Slider_index] = 0;
fDIJOYSTATE.lX = 0;
fDIJOYSTATE.lY = 0;
fDIJOYSTATE.lZ = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIJOYSTATE* __fastcall TDIJoyState::FGetInternal_DIJOYSTATE_Ptr()
{
return &fDIJOYSTATE;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::FSetInternal_DIJOYSTATE( DIJOYSTATE* pDIJOYSTATE )
{
if (pDIJOYSTATE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState::FSetInternal_DIJOYSTATE()", "TDX_ERROR", "The supplied DIJOYSTATE* was NULL" );
    return;
    }

CopyMemory( &fDIJOYSTATE, pDIJOYSTATE, sizeof(DIJOYSTATE) );
Internal_DIJOYSTATE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState::Internal_DIJOYSTATE_Update()
{
}

// --------------------------------------------------------------------------
