// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIKeyboardState.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIKeyboardState 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIKeyboardState.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIKeyboardState*)
{
    new TDIKeyboardState(NULL);
}
// --------------------------------------------------------------------------
namespace Tdikeyboardstate
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIKeyboardState)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIKeyboardState::TDIKeyboardState()
// Description: The default constructor for the TDIKeyboardState object.
// --------------------------------------------------------------------------
__fastcall TDIKeyboardState::TDIKeyboardState(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIKeyboardState::~TDIKeyboardState()
// Description: The destructor for the TDIKeyboardState object.
// --------------------------------------------------------------------------
__fastcall TDIKeyboardState::~TDIKeyboardState()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIKeyboardState method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIKeyboardState::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Keys
// Description: The Keys property is used to store results from the 
//              TDx_InputDevice::GetDeviceState() method as a 256 byte array. 
//              
//              When a given key is down, the high-order bit of the 
//              corresponding byte will be set. 
//              If the key is up, or does not exist, the bit will be clear. 
// --------------------------------------------------------------------------
byte __fastcall TDIKeyboardState::FGetKeys( dword pIndex )
{
if (pIndex>=256)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIKeyboardState::FGetKeys()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (BYTE) NULL;
    }
return fDIKEYBOARDSTATE.bKeys[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::FSetKeys( dword pIndex, byte pKeys )
{
fDIKEYBOARDSTATE.bKeys[pIndex] = pKeys;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIKEYBOARDSTATE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIKeyboardState::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIKeyboardState's internal DIKEYBOARDSTATE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::Clear()
{
fErrorValue = DI_OK;
for (int Keys_index=0;Keys_index<256;Keys_index++) fDIKEYBOARDSTATE.bKeys[Keys_index] = 0;
fSize = sizeof(DIKEYBOARDSTATE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIKEYBOARDSTATE* __fastcall TDIKeyboardState::FGetInternal_DIKEYBOARDSTATE_Ptr()
{
return &fDIKEYBOARDSTATE;
}
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::FSetInternal_DIKEYBOARDSTATE( DIKEYBOARDSTATE* pDIKEYBOARDSTATE )
{
if (pDIKEYBOARDSTATE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIKeyboardState::FSetInternal_DIKEYBOARDSTATE()", "TDX_ERROR", "The supplied DIKEYBOARDSTATE* was NULL" );
    return;
    }

CopyMemory( &fDIKEYBOARDSTATE, pDIKEYBOARDSTATE, sizeof(DIKEYBOARDSTATE) );
Internal_DIKEYBOARDSTATE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIKeyboardState::Internal_DIKEYBOARDSTATE_Update()
{
}

// --------------------------------------------------------------------------
