// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIMouseState.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIMouseState Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIMouseState.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIMouseState*)
{
    new TDIMouseState(NULL);
}
// --------------------------------------------------------------------------
namespace Tdimousestate
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIMouseState)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIMouseState::TDIMouseState()
// Description: The default constructor for the TDIMouseState object.
// --------------------------------------------------------------------------
__fastcall TDIMouseState::TDIMouseState(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIMouseState::~TDIMouseState()
// Description: The destructor for the TDIMouseState object.
// --------------------------------------------------------------------------
__fastcall TDIMouseState::~TDIMouseState()
{
}
// --------------------------------------------------------------------------
// Property:    Buttons
// Description: The Buttons property defines a byte array of up to 4 button 
//              states. 
//              
//              When a given button is down, the high-order bit of the 
//              corresponding byte will be set. 
//              If the button is up, or does not exist, the bit will be 
//              clear. 
// --------------------------------------------------------------------------
byte __fastcall TDIMouseState::FGetButtons( dword pIndex )
{
if (pIndex>=4)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIMouseState::FGetButtons()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (BYTE) NULL;
    }
return fDIMOUSESTATE.rgbButtons[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetButtons( dword pIndex, byte pButtons )
{
fDIMOUSESTATE.rgbButtons[pIndex] = pButtons;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIMouseState method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIMouseState::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIMOUSESTATE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIMouseState::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property describes movement of the mouse's X axis, 
//              which usually represents the left right movement of the 
//              mouse. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState::FGetX()
{
return fDIMOUSESTATE.lX;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetX( long pX )
{
fDIMOUSESTATE.lX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property describes movement of the mouse's Y axis, 
//              which usually represents the forward backward movement of the 
//              mouse. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState::FGetY()
{
return fDIMOUSESTATE.lY;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetY( long pY )
{
fDIMOUSESTATE.lY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property describes movement of the mouse's Z axis, 
//              which is usually a wheel between the buttons. 
//              
//              When there is no Z axis this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState::FGetZ()
{
return fDIMOUSESTATE.lZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetZ( long pZ )
{
fDIMOUSESTATE.lZ = pZ;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIMouseState's internal DIMOUSESTATE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::Clear()
{
for (int Buttons_index=0;Buttons_index<4;Buttons_index++) fDIMOUSESTATE.rgbButtons[Buttons_index] = 0;
fErrorValue = DI_OK;
fSize = sizeof(DIMOUSESTATE);
fDIMOUSESTATE.lX = 0;
fDIMOUSESTATE.lY = 0;
fDIMOUSESTATE.lZ = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIMOUSESTATE* __fastcall TDIMouseState::FGetInternal_DIMOUSESTATE_Ptr()
{
return &fDIMOUSESTATE;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::FSetInternal_DIMOUSESTATE( DIMOUSESTATE* pDIMOUSESTATE )
{
if (pDIMOUSESTATE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIMouseState::FSetInternal_DIMOUSESTATE()", "TDX_ERROR", "The supplied DIMOUSESTATE* was NULL" );
    return;
    }

CopyMemory( &fDIMOUSESTATE, pDIMOUSESTATE, sizeof(DIMOUSESTATE) );
Internal_DIMOUSESTATE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState::Internal_DIMOUSESTATE_Update()
{
}

// --------------------------------------------------------------------------
