// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPropDWORD.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPropDWORD Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPropDWORD.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPropDWORD*)
{
    new TDIPropDWORD(NULL);
}
// --------------------------------------------------------------------------
namespace Tdipropdword
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPropDWORD)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPropDWORD::TDIPropDWORD()
// Description: The default constructor for the TDIPropDWORD object.
// --------------------------------------------------------------------------
__fastcall TDIPropDWORD::TDIPropDWORD(TComponent* Owner)
    : TDIProperty(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPropDWORD::~TDIPropDWORD()
// Description: The destructor for the TDIPropDWORD object.
// --------------------------------------------------------------------------
__fastcall TDIPropDWORD::~TDIPropDWORD()
{
}
// --------------------------------------------------------------------------
// Property:    Data
// Description: The Data property defines value being set or retrieved. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropDWORD::FGetData()
{
return fDIPROPDWORD.dwData;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::FSetData( dword pData )
{
fDIPROPDWORD.dwData = pData;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPropDWORD method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPropDWORD::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    PropHeader
// Description: The PropHeader property can be used to link the TDIPropDWORD 
//              to a TDIPropHeader component using the Object Inspector or 
//              equivalent runtime code, and is used to access data inside 
//              the DIPROPHEADER structure that exists inside a DIPROPDWORD 
//              structure in a structure-in-structure relationship. 
//              
//              Normally in DirectX, you must setup the entire DIPROPDWORD 
//              structure including it's DIPROPHEADER structure according to 
//              specific rules. Upon linking a TDIPropHeader component to a 
//              TDIPropDWORD, much of the work has already been performed, 
//              but you still need to setup both the TDIPropHeader::Obj and 
//              the TDIPropHeader::How properties. 
//              
//              For Example :- 
//              
//              void __fastcall Form1::Button1Click(TObject* Sender) 
//              { 
//              DIPropHeader1->How = DIPH_DEVICE; 
//              DIPropHeader1->Obj = 0; 
//              
//              DIPropDWORD1->Data = 20; 
//              DIPropDWORD1->PropHeader = DIPropHeader1; 
//              
//              Dx_InputDevice1->SetProperty( DIPROP_BUFFERSIZE, DIPropDWORD1 
//              ); 
//              } 
// --------------------------------------------------------------------------
TDIPropHeader* __fastcall TDIPropDWORD::FGetPropHeader()
{
if (ComponentState.Contains(csDesigning) &&
    (fPropHeader!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPropHeader)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPropHeader=NULL;
    }
return fPropHeader;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::FSetPropHeader( TDIPropHeader* pPropHeader )
{
fPropHeader = pPropHeader;
if (fPropHeader!=NULL) fPropHeader->Size = Size;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIPROPDWORD structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropDWORD::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPropDWORD's internal DIPROPDWORD structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::Clear()
{
fDIPROPDWORD.dwData = 0;
fErrorValue = DI_OK;
fPropHeader = NULL;
fSize = sizeof(DIPROPDWORD);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPROPDWORD* __fastcall TDIPropDWORD::FGetInternal_DIPROPDWORD_Ptr()
{
if (fPropHeader!=NULL) CopyMemory( &fDIPROPDWORD.diph, fPropHeader->Internal_DIPROPHEADER_Ptr, sizeof(DIPROPHEADER) );
return &fDIPROPDWORD;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::FSetInternal_DIPROPDWORD( DIPROPDWORD* pDIPROPDWORD )
{
if (pDIPROPDWORD==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPropDWORD::FSetInternal_DIPROPDWORD()", "TDX_ERROR", "The supplied DIPROPDWORD* was NULL" );
    return;
    }

CopyMemory( &fDIPROPDWORD, pDIPROPDWORD, sizeof(DIPROPDWORD) );
Internal_DIPROPDWORD_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPropDWORD::Internal_DIPROPDWORD_Update()
{
if (fPropHeader!=NULL) CopyMemory( fPropHeader->Internal_DIPROPHEADER_Ptr, &fDIPROPDWORD.diph, sizeof(DIPROPHEADER) );
}

// --------------------------------------------------------------------------
