// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPropGuidAndPath.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPropGuidAndPath 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPropGuidAndPath.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPropGuidAndPath*)
{
    new TDIPropGuidAndPath(NULL);
}
// --------------------------------------------------------------------------
namespace Tdipropguidandpath
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPropGuidAndPath)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPropGuidAndPath::TDIPropGuidAndPath()
// Description: The default constructor for the TDIPropGuidAndPath object.
// --------------------------------------------------------------------------
__fastcall TDIPropGuidAndPath::TDIPropGuidAndPath(TComponent* Owner)
    : TDIProperty(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPropGuidAndPath::~TDIPropGuidAndPath()
// Description: The destructor for the TDIPropGuidAndPath object.
// --------------------------------------------------------------------------
__fastcall TDIPropGuidAndPath::~TDIPropGuidAndPath()
{
}
// --------------------------------------------------------------------------
// Property:    Class
// Description: The Class property defines the class GUID of the device or 
//              object. 
// --------------------------------------------------------------------------
GUID __fastcall TDIPropGuidAndPath::FGetClass()
{
return fDIPROPGUIDANDPATH.guidClass;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetClass( GUID pClass )
{
fDIPROPGUIDANDPATH.guidClass = pClass;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPropGuidAndPath method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPropGuidAndPath::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Path
// Description: The Path property defines the device interface path for the 
//              device or object. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIPropGuidAndPath::FGetPath()
{
AnsiString tempPath = fDIPROPGUIDANDPATH.wszPath;
return tempPath;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetPath( AnsiString pPath )
{
int max = pPath.Length();
if (max>MAX_PATH) max = MAX_PATH;
CopyMemory( &fDIPROPGUIDANDPATH.wszPath[0], pPath.c_str(), max*2 );
}
// --------------------------------------------------------------------------
// Property:    PropHeader
// Description: The PropHeader property can be used to link the 
//              TDIPropGuidAndPath to a TDIPropHeader component using the 
//              Object Inspector or equivalent runtime code, and is used to 
//              access data inside the DIPROPHEADER structure that exists 
//              inside a DIPROPGUIDANDPATH structure in a 
//              structure-in-structure relationship. 
//              
//              Normally in DirectX, you must setup the entire 
//              DIPROPGUIDANDPATH structure including it's DIPROPHEADER 
//              structure according to specific rules. Upon linking a 
//              TDIPropHeader component to a TDIPropGuidAndPath, much of the 
//              work has already been performed, but you still need to setup 
//              both the TDIPropHeader::Obj and the TDIPropHeader::How 
//              properties. 
// --------------------------------------------------------------------------
TDIPropHeader* __fastcall TDIPropGuidAndPath::FGetPropHeader()
{
if (ComponentState.Contains(csDesigning) &&
    (fPropHeader!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPropHeader)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPropHeader=NULL;
    }
return fPropHeader;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetPropHeader( TDIPropHeader* pPropHeader )
{
fPropHeader = pPropHeader;
if (fPropHeader!=NULL) fPropHeader->Size = Size;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIPROPGUIDANDPATH structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropGuidAndPath::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPropGuidAndPath's internal DIPROPGUIDANDPATH structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::Clear()
{
ZeroMemory(&fClass,sizeof(_GUID));
fErrorValue = DI_OK;
fPropHeader = NULL;
fSize = sizeof(DIPROPGUIDANDPATH);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPROPGUIDANDPATH* __fastcall TDIPropGuidAndPath::FGetInternal_DIPROPGUIDANDPATH_Ptr()
{
if (fPropHeader!=NULL) CopyMemory( &fDIPROPGUIDANDPATH.diph, fPropHeader->Internal_DIPROPHEADER_Ptr, sizeof(DIPROPHEADER) );
return &fDIPROPGUIDANDPATH;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::FSetInternal_DIPROPGUIDANDPATH( DIPROPGUIDANDPATH* pDIPROPGUIDANDPATH )
{
if (pDIPROPGUIDANDPATH==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPropGuidAndPath::FSetInternal_DIPROPGUIDANDPATH()", "TDX_ERROR", "The supplied DIPROPGUIDANDPATH* was NULL" );
    return;
    }

CopyMemory( &fDIPROPGUIDANDPATH, pDIPROPGUIDANDPATH, sizeof(DIPROPGUIDANDPATH) );
Internal_DIPROPGUIDANDPATH_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPropGuidAndPath::Internal_DIPROPGUIDANDPATH_Update()
{
if (fPropHeader!=NULL) CopyMemory( fPropHeader->Internal_DIPROPHEADER_Ptr, &fDIPROPGUIDANDPATH.diph, sizeof(DIPROPHEADER) );
}

// --------------------------------------------------------------------------
