#ifndef TDIPropGuidAndPathH
#define TDIPropGuidAndPathH

// ==========================================================================
// File:         TDIPropGuidAndPath.H
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file defines the TDIPropGuidAndPath Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
#include "TDx_Library_Defns.H"
#include "TDx_Library_Functions.H"
// --------------------------------------------------------------------------
#include "TDx_Input_Library_Defns.H"
#include "TDx_Input_Library_Functions.H"
// --------------------------------------------------------------------------
// external classes used by TDIPropGuidAndPath properties.
#include "TDIPropHeader.H"

// --------------------------------------------------------------------------
// ==========================================================================
// Class:       TDIPropGuidAndPath
// Description: The TDIPropGuidAndPath component wraps the DirectX 
//              TDIPROPGUIDANDPATH structure which is used to access GUID and 
//              path properties. 
//              
//              This component is primarily utilised by the 
//              TDx_InputDevice::GetProperty() and 
//              TDx_InputDevice::SetProperty() methods to perform operations 
//              on a HID that are not otherwise supported. 
//              
//              This component also references a TDIPropHeader component. 
// ==========================================================================
#if (__BORLANDC__ >= 0x0530) // BCB Version 3 +
class PACKAGE TDIPropGuidAndPath : public TDIProperty
{
// --------------------------------------------------------------------------
#else // BCB Version 1
class TDIPropGuidAndPath : public TDIProperty
{
#endif
// ==========================================================================
__published:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Property:    Path
    // Description: The Path property defines the device interface path for 
    //              the device or object. 
    // ----------------------------------------------------------------------
    __property AnsiString Path = { read=FGetPath, write=FSetPath, nodefault 
    }; 

    // ----------------------------------------------------------------------
    // Property:    PropHeader
    // Description: The PropHeader property can be used to link the 
    //              TDIPropGuidAndPath to a TDIPropHeader component using the 
    //              Object Inspector or equivalent runtime code, and is used 
    //              to access data inside the DIPROPHEADER structure that 
    //              exists inside a DIPROPGUIDANDPATH structure in a 
    //              structure-in-structure relationship. 
    //              
    //              Normally in DirectX, you must setup the entire 
    //              DIPROPGUIDANDPATH structure including it's DIPROPHEADER 
    //              structure according to specific rules. Upon linking a 
    //              TDIPropHeader component to a TDIPropGuidAndPath, much of 
    //              the work has already been performed, but you still need 
    //              to setup both the TDIPropHeader::Obj and the 
    //              TDIPropHeader::How properties. 
    // ----------------------------------------------------------------------
    __property TDIPropHeader* PropHeader = { read=FGetPropHeader, 
    write=FSetPropHeader, default=NULL }; 

    // ----------------------------------------------------------------------
    // Event:       OnError()
    // Description: The OnError event is called when an error occurs in the 
    //              TDIPropGuidAndPath component. 
    // ----------------------------------------------------------------------
    __property TDx_Error OnError = {read=FOnError, write=FOnError, 
    nodefault}; 

// ==========================================================================
public:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Property:    Class
    // Description: The Class property defines the class GUID of the device 
    //              or object. 
    // ----------------------------------------------------------------------
    __property GUID Class = { read=FGetClass, write=FSetClass, nodefault }; 

    // ----------------------------------------------------------------------
    // Property:    ErrorValue
    // Description: The ErrorValue property contains the last error value 
    //              returned from a call to a TDIPropGuidAndPath method or 
    //              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
    // ----------------------------------------------------------------------
    __property HRESULT ErrorValue = { read=FGetErrorValue, 
    write=FSetErrorValue, default=DI_OK }; 

    // ----------------------------------------------------------------------
    // Property:    Size
    // Description: The Size property contains the size in bytes of the 
    //              internal DIPROPGUIDANDPATH structure. 
    // ----------------------------------------------------------------------
    __property dword Size = { read=FGetSize, write=FSetSize, nodefault }; 

    // ----------------------------------------------------------------------
    // Method:      Clear()
    // Description: The Clear() method can be used to clear the contents of 
    //              the TDIPropGuidAndPath's internal DIPROPGUIDANDPATH 
    //              structure. 
    //              Note: if you have manually linked a structure member to a 
    //              chunk of memory, make sure you release this memory before 
    //              calling Clear(). 
    // ----------------------------------------------------------------------
    virtual void __fastcall Clear(); 

    // ----------------------------------------------------------------------
    // Constructor() and Destructor()
    // ----------------------------------------------------------------------
    __fastcall TDIPropGuidAndPath(TComponent* Owner); 
    virtual __fastcall ~TDIPropGuidAndPath(); 

    // ----------------------------------------------------------------------
    // Internal Structure Access 
    // ----------------------------------------------------------------------
    __property DIPROPGUIDANDPATH* Internal_DIPROPGUIDANDPATH_Ptr = { 
    read=FGetInternal_DIPROPGUIDANDPATH_Ptr, nodefault }; 

    void __fastcall Internal_DIPROPGUIDANDPATH_Update(); 

// ==========================================================================
protected:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Property Access Methods
    // ----------------------------------------------------------------------
    GUID __fastcall FGetClass(); 
    void __fastcall FSetClass( GUID pClass ); 
    HRESULT __fastcall FGetErrorValue(); 
    void __fastcall FSetErrorValue( HRESULT pErrorValue ); 
    AnsiString __fastcall FGetPath(); 
    void __fastcall FSetPath( AnsiString pPath ); 
    TDIPropHeader* __fastcall FGetPropHeader(); 
    void __fastcall FSetPropHeader( TDIPropHeader* pPropHeader ); 
    dword __fastcall FGetSize(); 
    void __fastcall FSetSize( dword pSize ); 

// ==========================================================================
private:
// ==========================================================================

    // ----------------------------------------------------------------------
    // Internal Structure Access 
    // ----------------------------------------------------------------------
    DIPROPGUIDANDPATH* __fastcall FGetInternal_DIPROPGUIDANDPATH_Ptr(); 
    void __fastcall FSetInternal_DIPROPGUIDANDPATH( DIPROPGUIDANDPATH* 
    pDIPROPGUIDANDPATH ); 

    // ----------------------------------------------------------------------
    // Property Variables 
    // ----------------------------------------------------------------------
    GUID fClass; 
    HRESULT fErrorValue; 
    TDIPropHeader* fPropHeader; 
    dword fSize; 

    // ----------------------------------------------------------------------
    // Structure Variables 
    // ----------------------------------------------------------------------
    DIPROPGUIDANDPATH fDIPROPGUIDANDPATH; 

    // ----------------------------------------------------------------------
    // Event Variables
    // ----------------------------------------------------------------------
    TDx_Error FOnError;

};
// --------------------------------------------------------------------------
#endif
// --------------------------------------------------------------------------
