// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPropString.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPropString Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPropString.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPropString*)
{
    new TDIPropString(NULL);
}
// --------------------------------------------------------------------------
namespace Tdipropstring
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPropString)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPropString::TDIPropString()
// Description: The default constructor for the TDIPropString object.
// --------------------------------------------------------------------------
__fastcall TDIPropString::TDIPropString(TComponent* Owner)
    : TDIProperty(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPropString::~TDIPropString()
// Description: The destructor for the TDIPropString object.
// --------------------------------------------------------------------------
__fastcall TDIPropString::~TDIPropString()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPropString method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPropString::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    PropHeader
// Description: The PropHeader property can be used to link the TDIPropString 
//              to a TDIPropHeader component using the Object Inspector or 
//              equivalent runtime code, and is used to access data inside 
//              the DIPROPHEADER structure that exists inside a DIPROPSTRING 
//              structure in a structure-in-structure relationship. 
//              
//              Normally in DirectX, you must setup the entire DIPROPSTRING 
//              structure including it's DIPROPHEADER structure according to 
//              specific rules. Upon linking a TDIPropHeader component to a 
//              TDIPropString, much of the work has already been performed, 
//              but you still need to setup both the TDIPropHeader::Obj and 
//              the TDIPropHeader::How properties. 
//              
//              For Example :- 
//              
//              void __fastcall Form1::Button1Click(TObject* Sender) 
//              { 
//              DIPropHeader1->How = DIPH_DEVICE; 
//              DIPropHeader1->Obj = 0; 
//              
//              DIPropString1->String = "My Device"; 
//              DIPropString1->PropHeader = DIPropHeader1; 
//              
//              Dx_InputDevice1->SetProperty( DIPROP_PRODUCTNAME, 
//              DIPropString1 ); 
//              } 
// --------------------------------------------------------------------------
TDIPropHeader* __fastcall TDIPropString::FGetPropHeader()
{
if (ComponentState.Contains(csDesigning) &&
    (fPropHeader!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPropHeader)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPropHeader=NULL;
    }
return fPropHeader;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::FSetPropHeader( TDIPropHeader* pPropHeader )
{
fPropHeader = pPropHeader;
if (fPropHeader!=NULL) fPropHeader->Size = Size;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIPROPSTRING structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropString::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    String
// Description: The String property defines the instance or product name as a 
//              string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIPropString::FGetString()
{
AnsiString tempString = fDIPROPSTRING.wsz;
return tempString;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::FSetString( AnsiString pString )
{
int max = pString.Length();
if (max>MAX_PATH) max = MAX_PATH;
CopyMemory( &fDIPROPSTRING.wsz[0], pString.c_str(), max*2 );
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPropString's internal DIPROPSTRING structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPropString::Clear()
{
fErrorValue = DI_OK;
fPropHeader = NULL;
fSize = sizeof(DIPROPSTRING);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPROPSTRING* __fastcall TDIPropString::FGetInternal_DIPROPSTRING_Ptr()
{
if (fPropHeader!=NULL) CopyMemory( &fDIPROPSTRING.diph, fPropHeader->Internal_DIPROPHEADER_Ptr, sizeof(DIPROPHEADER) );
return &fDIPROPSTRING;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::FSetInternal_DIPROPSTRING( DIPROPSTRING* pDIPROPSTRING )
{
if (pDIPROPSTRING==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPropString::FSetInternal_DIPROPSTRING()", "TDX_ERROR", "The supplied DIPROPSTRING* was NULL" );
    return;
    }

CopyMemory( &fDIPROPSTRING, pDIPROPSTRING, sizeof(DIPROPSTRING) );
Internal_DIPROPSTRING_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPropString::Internal_DIPROPSTRING_Update()
{
if (fPropHeader!=NULL) CopyMemory( fPropHeader->Internal_DIPROPHEADER_Ptr, &fDIPROPSTRING.diph, sizeof(DIPROPHEADER) );
}

// --------------------------------------------------------------------------
