// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIRampForce.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIRampForce Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIRampForce.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIRampForce*)
{
    new TDIRampForce(NULL);
}
// --------------------------------------------------------------------------
namespace Tdirampforce
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIRampForce)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIRampForce::TDIRampForce()
// Description: The default constructor for the TDIRampForce object.
// --------------------------------------------------------------------------
__fastcall TDIRampForce::TDIRampForce(TComponent* Owner)
    : TDIForce(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIRampForce::~TDIRampForce()
// Description: The destructor for the TDIRampForce object.
// --------------------------------------------------------------------------
__fastcall TDIRampForce::~TDIRampForce()
{
}
// --------------------------------------------------------------------------
// Property:    End
// Description: The End property defines the ending magnitude for the effect. 
//              
//              This value can range from -10,000 to 10,000, the extreemes of 
//              which represent the maximum force output the device is 
//              capable of in either direction. 
// --------------------------------------------------------------------------
long __fastcall TDIRampForce::FGetEnd()
{
return fDIRAMPFORCE.lEnd;
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::FSetEnd( long pEnd )
{
fDIRAMPFORCE.lEnd = pEnd;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIRampForce method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIRampForce::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIRAMPFORCE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIRampForce::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Start
// Description: The Start property defines the starting magnitude for the 
//              effect. 
//              
//              This value can range from -10,000 to 10,000, the extreemes of 
//              which represent the maximum force output the device is 
//              capable of in either direction. 
// --------------------------------------------------------------------------
long __fastcall TDIRampForce::FGetStart()
{
return fDIRAMPFORCE.lStart;
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::FSetStart( long pStart )
{
fDIRAMPFORCE.lStart = pStart;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIRampForce's internal DIRAMPFORCE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::Clear()
{
fDIRAMPFORCE.lEnd = 0;
fErrorValue = DI_OK;
fSize = sizeof(DIRAMPFORCE);
fDIRAMPFORCE.lStart = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIRAMPFORCE* __fastcall TDIRampForce::FGetInternal_DIRAMPFORCE_Ptr()
{
return &fDIRAMPFORCE;
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::FSetInternal_DIRAMPFORCE( DIRAMPFORCE* pDIRAMPFORCE )
{
if (pDIRAMPFORCE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIRampForce::FSetInternal_DIRAMPFORCE()", "TDX_ERROR", "The supplied DIRAMPFORCE* was NULL" );
    return;
    }

CopyMemory( &fDIRAMPFORCE, pDIRAMPFORCE, sizeof(DIRAMPFORCE) );
Internal_DIRAMPFORCE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIRampForce::Internal_DIRAMPFORCE_Update()
{
}

// --------------------------------------------------------------------------
